unit fer318;
 

  interface  
    
 {$R-}
 
	

 uses  ferm118{,  Types}, QGraphics {QuickDraw} {,Paslibintf, Events, Dialogs,
       Memory, ToolUtils, OSUtils};

var

  polygarb: poly;
  { quolygarb: quoly; }
  polynames: polypt;
  number_polys: longint;
  cutoff: longint;
  polyvar: array[1..100] of nametype;
  stash: workptr;  { system's space for its array syst }
  quol_num_0: quoly;   
			
  

 procedure newpoly(var p: poly);
 
 procedure newquoly(var q: quoly);
 
 procedure free_poly(var p: poly);
 
 procedure free_quoly(var q: quoly);

 procedure poly_inplace(p: poly);
 
 procedure quoly_inplace(p: quoly);
 
 procedure check_and_assign(k: longint; var q: quoly);  
 
 procedure poly_great_int(var p: poly);
 
 procedure newcolm(var q: colm_ptr);
 
 procedure sparse_set_scalar(q: arrptr; cols: longint; n: quoly);  {```}
 
 procedure purge_sparse(t: colm_ptrptr; c: longint);  { Nov 1997 }
 
 procedure sparse_delete(r, c: longint; q: arrptr; colflag: boolean); { Nov 1997 }
 
 procedure sparse_zero_set(t: colm_ptrptr; c: longint; var qp: quolyptr);  { Nov 1997 }
 
 procedure sparse_set(r, c: longint; q: arrptr; var qp: quolyptr; colflag: boolean);
                                              { Dec 1997 }
 procedure sparse_insert(r, c: longint; q: arrptr; colflag: boolean; var n: quoly);
 
 procedure isparse_insert(r, c: longint; n: longreal; q: arrptr; colflag, 
                assign: boolean);  { Nov 1997 }
 
 procedure sparse_init(var spar: sparseptr; r: longint); {```}
 
 procedure free_sparse(var spar: sparseptr; dim: longint; arr_free: boolean);
 
 procedure free_sparse_frame(var spar: sparseptr; dim: longint);
 
 procedure copy_sparse(var s, t: sparseptr; dim: longint; neg: boolean);
 
 procedure spar_identi(var spar: sparseptr; rows: longint; arr_free: boolean);
 
 procedure sparse_makeneg(var spar: sparseptr; rows: longint; var arr_free: boolean);
 
 procedure copy_syst(var arr: workarray; rows: longint; var spar: sparseptr);{ Nov 1997 }
 
 function lastnum(n: poly): poly;
 
 function lastnode(n: poly): poly;
 
 procedure poly_assign(p: poly; var q: poly);
 
 procedure quoly_assign(p: quoly; var q: quoly);
 
 procedure quoly_to_poly(q: quoly; var p: poly);
 
 procedure poly_to_quoly(p: poly; var q: quoly);
 
 procedure p_q_assign(p: poly; var q: quoly);
 
 procedure polynum_to_quoly(var q: quoly);
 
 procedure sub_expons(u: poly; var utail: poly; uexp: longint); 
 
 procedure restore_exps(u, utail: poly; uexp: longint); 
  
 procedure poly_imag_free(var p: poly);
 
 procedure poly_imag_part(var p: poly);
 
 procedure poly_conjugate(p: poly);
 
 procedure garbage(x: nametype);
 
 procedure poly_makeneg(p: poly; var q: poly);
 
 procedure quoly_makeneg(p: quoly; var q: quoly);
  
 procedure scalar_to_poly(var n: number; var p: poly);
 
 procedure scalar_to_quoly(var n: number; var p: quoly);
 
 procedure poly_set(num: longint; var p: poly);
 
 procedure poly_set_ext(num: longreal; var p: poly); { Dec 1997 }
 
 procedure quoly_set(num: longint; var p: quoly);
 
 procedure quoly_set_ext(num: longreal; var p: quoly);
 
 function convert_to_int(var n: number): longint; 
 
 function quoly_convert_to_int(p: quoly): longint;
 
 function pos_imag_part(p: poly): boolean;
 
 procedure poly_to_scalar(p: poly; var n: number);
 
 procedure quoly_to_scalar(p: quoly; var n: number);
 
 function poly_length(n: poly): longint;
 
 function maxx(a, b: integer): integer;
 
 function depth_below(p: poly): integer;
 
 function poly_height(p: poly): integer;
 
 function quoly_mass(n: quoly): longint;
 
 function poly_small(n: poly): boolean;
 
 function is_array_param(p: quoly): boolean;
 
 function is_poly_name(x: nametype; var depth: longint): boolean;
 
 function its_a_polyname(x: nametype): boolean;
 
 procedure is_poly_name2(x: nametype; var depth: longint; var q: polypt);  
 
 procedure delete_poly_name(depth: longint);
 
 procedure remove_poly_var(var q: quoly; depth: longint);
 
 procedure base_poly(var p: poly; depth: longint);
 
 procedure base_quoly(var p: quoly; depth: longint);
 
 function poly_equal(p,q: poly): boolean;
 
 function quoly_equal(p,q: quoly): boolean;
 
 function poly_iszero(p: poly): boolean;
 
 function node_iszero(p: poly): boolean;
 
 function quoly_iszero(p: quoly): boolean;
 
 function node_total(n: poly): longint;
 
 function poly_level(n: poly): longint;
 
 function poly_eq_1(p: poly): boolean;
 
 function quoly_eq_1(p: quoly): boolean;
 
 function essentially_equal(p, q: poly): boolean;
 
 function pos_leading_coef(p: poly): boolean;
 
 function poly_depth(p: poly): integer;
 
 function height_is_1(n: poly): boolean;
 
 procedure findHeight(var n, m: poly; var h: integer);
 
 function leading_coef(n: poly): poly;
 
 procedure quoly_consume(var n: quoly; var p: poly);
 
 procedure poly_consume(var n: poly; var q: quoly);
 
 function quoly_convert_to_ext(p: quoly): longreal;
 
 procedure quoly_convert_to_comp(p: quoly; var x, y: longreal);
 
 function spec_convert_to_int(p: quoly): longint;
 
 procedure initialize;
 
 procedure switchrow_col(index, j, k, start, total_rows, target_rows, cols: longint);
 
 procedure fillup(rows, cols, start: longint; var arr: workarray);
 
 procedure findbest(start, stop, rows, i: longint; var j, k: longint);
 
 function better_number(var n1, n2: number): boolean;  { Oct 2000, moved here from 218 }
 
 function close_to_0(var n1: number): boolean;   { Oct 2000 }
 
 procedure colfindbest(start, rows, i, col: longint; var j: longint);  { Oct 2000 } 
 
 procedure swap_rows(var n: quoly; var dup: workarray; want_n, do_all: boolean;
                     i, j, m: longint);
					
 procedure swap_cols(var arr: workarray; i, j, rows: longint);
  
 procedure identi(var arr: workarray; rows: longint; arr_free: boolean);
  					

implementation

	
 procedure newpoly { (var p: poly) };
	
    begin
      if polygarb = nil
        then new(p)
        else begin
                p := polygarb;
                polygarb := polygarb^.next
             end
						 
	end;
						 
 {***************************************************************}
  
 procedure newquoly { (var q: quoly) };
	
    begin
      if quolygarb = nil
         then new(q)
         else begin
                 q := quolygarb;
                 quolygarb := quolygarb^.next
              end
						 
	end;
						 
 {******************************************************************}
 
 procedure free_poly { (var p: poly) };
 
    { assume p<>nil means there is something to be freed. p is left nil}
 
    var q, tail: poly;
 
    begin
	
	   q := p;	   
	   while q <> nil do
	      begin
		     if q^.numb
			     then free_imag(q^.ncoef)
			     else free_poly(q^.pcoef);
			  if q^.next = nil then tail := q;
			  q := q^.next
		   end;
	   if p <> nil 
	      then begin
		           tail^.next := polygarb;
	              polygarb := p;
	              p := nil
			     end 
			   
	end;
	
 {******************************************************************}
 
 procedure free_quoly { (var q: quoly) };
 
    { assume q<>nil means there is something to be freed. q is left nil}
 
    begin
	
	   if q = nil
	      then exit {(free_quoly)};
	   if q^.numb
		  then free_imag(q^.ncoef)
		  else begin
		          free_poly(q^.numer);
			       if q^.denom <> nil 
				       then free_poly(q^.denom);
			    end;
	   q^.next := quolygarb;
	   quolygarb := q;
	   q := nil
			   
	end;
	
 {*************************************************************************}

 procedure poly_great_int { (var p: poly) };
 
    var q,t: poly;
	
	procedure remove;	
	   begin
	      if t = nil
		     then begin
			         p := q^.next;
					   q^.next := nil;
					   free_poly(q);
					   q := p
				    end
		  else begin
		          t^.next := q^.next;
				    q^.next := nil;
				    free_poly(q);
				    q := t^.next
			    end
       end;
 
    begin
	   
	   q := p;
	   t := nil;
	   while q <> nil do
	      begin
		     if q^.numb
			    then complex_great_int(q^.ncoef^, q^.ncoef^)
			    else poly_great_int(q^.pcoef);
			  if q^.numb
			    then if node_iszero(q)
				        then remove
						  else begin
						        t := q;
								  q := q^.next
						       end
				 else if poly_iszero(q^.pcoef)
				         then remove
			            else begin
						          t := q;
								    q := q^.next
						        end
		  end;
	   if p = nil
	      then poly_set(0, p)
		  
	end;
	
 {************************************************************************}
  
 procedure newcolm { (var q: colm_ptr) };
	
    begin
      if col_garb = nil
         then new(q)
         else begin
                 q := col_garb;
                 col_garb := col_garb^.next
              end						 
	end;
						 
 {*************************************************************************}

 procedure poly_inplace { (p: poly)} ;
 
    begin
	   
	   while p <> nil do
	      begin
		     if p^.numb
			     then complex_inplace(p^.ncoef^)
			     else poly_inplace (p^.pcoef);
			  p := p^.next
		   end
		  
	end;
	
 {*************************************************************************}

 procedure quoly_inplace { (p: quoly)} ;
	 
	 begin
	   
	   if p^.numb
		   then complex_inplace(p^.ncoef^)
		   else poly_inplace(p^.numer);
		  
	end;
	
 {*************************************************************************}
 
 function lastnum; { (n: poly): poly; }
 
    begin
	   
	   while n^.next <> nil do
	      n := n^.next;
		  
	   if n^.numb
	      then lastnum := n
		   else lastnum := n^.pcoef
		  
    end;
	
 {*************************************************************************}
 
 function lastnode; { (n: poly): poly; }
 
    begin
	   
	   while n^.next <> nil do
	      n := n^.next;
		  
	   lastnode := n
	   
    end;
	
 {*************************************************************************}
 
 procedure poly_set { (num: longint; var p: poly) };
 
	begin
	
	   free_poly(p);
	   newpoly(p);
	   p^.next := nil;
	   p^.exp := 0;
	   p^.numb := true;
	   newimag(p^.ncoef);
	   p^.ncoef^.float := num;
		p^.ncoef^.imag := nil
	
	end;
		
 {*************************************************************************}
 
 procedure poly_set_ext { (num: longreal; var p: poly) }; { Dec 1997 }
 
	begin
	
	   free_poly(p);
	   newpoly(p);
	   p^.next := nil;
	   p^.exp := 0;
	   p^.numb := true;
	   newimag(p^.ncoef);
	   p^.ncoef^.float := num;
		p^.ncoef^.imag := nil
	
	end;
		
 {*************************************************************************}
 
 procedure quoly_set { (num: longint; var p: quoly) };
 
   { doesn't mod out num! }
 
	begin
	
	   free_quoly(p);
	   newquoly(p);
	   p^.numb := true;
	   newimag(p^.ncoef);
	   p^.ncoef^.float := num;
		p^.ncoef^.imag := nil
	   
	end;
		
 {*************************************************************************}
 
 procedure quoly_set_ext { (num: longreal; var p: quoly) };
 
	begin
	
	   free_quoly(p);
	   newquoly(p);
	   p^.numb := true;
	   newimag(p^.ncoef);
	   p^.ncoef^.float := num;
		p^.ncoef^.imag := nil
	   
	end;
		
  {****************************************************************************}
 
 procedure copy_syst; { var arr: workarray; rows: longint; var spar: sparseptr}
    var j: longint;  { Nov 1997 }
    begin
      if syst^.spar = nil
		   then for j := 0 to syst^.stop do
					  begin
						  arr[j] := nil;
						  quoly_assign(stash^[j], arr[j])
					  end
			else copy_sparse(syst^.spar, spar, rows, false)
	 end;
	 
  {*************************************************************************}
	
  procedure garbage { (x: nametype) } ;

    var p: numptr;
        n, tot: longint;
	    q: imptr;
	    t: varptr; 
		u: arrptr;
		v: poly;
		w: quoly;
		z: nameptr;
		a: graphptr;
		b: lineptr;
		c2: colm_ptr;
		c: objptr;
		s2: sparseptr;
		s: sidesptr;
		d: quadptr;
		cp: coordptr;
		  gp: polygon_ptr;
		  ft: factptr;
		  gg: grouptr;
		  eg: edgeptr;
		  fp: formptr;
		  cd: condexptr;
		  cl: colptr;

    begin

      p := numhead;
      n := 0;
	   tot := 0;
      while p <> nil do
        begin
          if x = 'G'
            then writeln(userOutput, p^.value);
          n := n + 1;
          p := p^.next
        end;
      writeln(userOutput, 'num size:', n: 5);
	   tot := tot + 8*n;
			
      q := imhead;
      n := 0;
      while q <> nil do
        begin
          n := n + 1;
          q := q^.imag
        end;
      writeln(userOutput, 'im size:', n: 5);
	   tot := tot + 18*n;
			
      t := var_garb;
      n := 0;
      while t <> nil do
        begin
          n := n + 1;
		      if x = 'G'
             then writeln(userOutput, t^.let.name);
          t := t^.next
        end;
      if n > 0
			then writeln(userOutput, 'var size:', n: 5);
		tot := tot + 28*n;
			
      z := name_garb;
      n := 0;
      while z <> nil do
        begin
          n := n + 1;
		    if x = 'G'
             then writeln(userOutput, z^.let.name);
          z := z^.next
        end;
      if n > 0
			then writeln(userOutput, 'name size:', n: 5);
		tot := tot + 25*n;
		
      u := arr_garb;
      n := 0;
      while u <> nil do
        begin
          n := n + 1;
		    if x = 'G'
             then writeln(userOutput, u^.name.name);
          u := u^.next
        end;
      if n > 0
			then writeln(userOutput, 'array size:', n: 5);
		tot := tot + 44*n;
			
      s2 := spargarb;
      n := 0;
      while s2 <> nil do
        begin
          n := n + 1;
          s2 := s2^.next
        end;
      if n > 0
		   then writeln(userOutput, 'sparse size:', n: 5);
		tot := tot + (sparsesize*4+5)*n;
		
		c2 := col_garb;
      n := 0;
      while c2 <> nil do
        begin
          n := n + 1;
          c2 := c2^.next
        end;
      tot := tot + 12*n;
		if n > 0
		   then writeln(userOutput, 'colm size:', n: 5);
			 
	   v := polygarb;
      n := 0;
      while v <> nil do
        begin
          n := n + 1;
		  if x = 'G'
            then writeln(userOutput, v^.exp); 
          v := v^.next
        end;
      writeln(userOutput, 'poly size:', n: 5);
		tot := tot + 12*n;
	  
	   w := quolygarb;
      n := 0;
      while w <> nil do
        begin
          n := n + 1;
          w := w^.next
        end;
      writeln(userOutput, 'quoly size:', n: 5);
		tot := tot + 13*n;
			
		cl := colgarb;
		n := 0;
      while cl <> nil do
        begin
          n := n + 1;
          cl := cl^.next
        end;
      if n > 0
		   then writeln(userOutput, 'matrix col size: ', n: 5);
	   tot := tot + 16*n;
		
		a := graph_garb; 
	   n := 0;
	   while a <> nil do
        begin
          n := n + 1;
          a := a^.next
        end;
     tot := tot + 1004*n;
	  if n <> 0
	     then writeln(userOutput, 'point size:', n: 5);
	  
	  b := line_garb;
	  n := 0;
	  while b <> nil do
        begin
          n := n + 1;
          b := b^.next
        end;
     tot := tot + 25*n;
	  if n <> 0
	     then writeln(userOutput, 'line size:', n: 5);
	  
	  c := obj_garb;
	  n := 0;
	  while c <> nil do
        begin
          n := n + 1;
          c := c^.next
        end;
     tot := tot + 163*n;
	  if n <> 0
	     then writeln(userOutput, 'object size:', n: 5);
			 
	  s := sides_garb;
	  n := 0;
	  while s <> nil do
        begin
          n := n + 1;
          s := s^.next
        end;
     tot := tot + 32*n;
	  if n <> 0
	     then writeln(userOutput, 'side size:', n: 5);
	  
	  d := quad_garb;
	  n := 0;
	  while d <> nil do
        begin
          n := n + 1;
          d := d^.next
        end;
     tot := tot + 20004*n;
	  if n <> 0
	     then writeln(userOutput, 'quad size:', n: 5);
		  
	  gp := gon_garb;
	  n := 0;
	  while gp <> nil do
        begin
          n := n + 1;
          gp := gp^.gg
        end;
     tot := tot + 28*n;
	  if n <> 0
	     then writeln(userOutput, 'polygon size:', n: 5);
		  
	  cp := point_garb;
	  n := 0;
	  while cp <> nil do
        begin
          n := n + 1;
          cp := cp^.cp
        end;
     tot := tot + 21*n;
	  if n <> 0
	     then writeln(userOutput, 'vertex size:', n: 5);
		  
	  eg := edge_garb;
	  n := 0;
	  while eg <> nil do
        begin
          n := n + 1;
          eg := eg^.next
        end;
     tot := tot + 79*n;
	  if n <> 0
	     then writeln(userOutput, 'edge size:', n: 5);
		  
	  ft := fact_garb;
	  n := 0;
	  while ft <> nil do
        begin
          n := n + 1;
          ft := ft^.next
        end;
     tot := tot + 13*n;
	  if n <> 0
	     then writeln(userOutput, 'facts size:', n: 5);
		  
	  gg := group_garb;
	  n := 0;
	  while gg <> nil do
        begin
           n := n + 1;
           gg := gg^.next
        end;
     tot := tot + 12*n;
	  if n <> 0
	     then writeln(userOutput, 'group size:', n: 5);
			 
		fp := formhead;  
      n := 0;
      while fp <> nil do
        begin
          n := n + 1;
          fp := fp^.next
        end;
      if n > 0
		   then writeln(userOutput, 'form node size:', n: 5); 
	   tot := tot + 12*n;
		
		cd := condhead;  
      n := 0;
      while cd <> nil do
        begin
          n := n + 1;
          cd := cd^.next
        end;
      if n > 0
		   then writeln(userOutput, 'cond expr size:', n: 5); 
	   tot := tot + 21*n;
		
	   n := 1;
		{ you can't just use first_available below. }
		while n <= worksize do
		   if workhead[n] = nil
			   then break
				else n := n + 1;
	   tot := (n-1)*arr_limit*4 + tot;
		if n-1 > 0
		   then writeln(userOutput, 'work arrays: ', n-1:5);
			
	   writeln(userOutput, 'total bytes:', tot: 10);
	   flush(output)

    end;

 {*************************************************************************}
 
 procedure poly_assign { (p: poly; var q: poly) };
 
    { q must be initialized }
 
    var dup, t: poly;
	    first: boolean;
 
    begin
	   
	   first := true;
	   while p <> nil do
	      begin
		     if first
			    then begin
				        newpoly(dup);
						  t := dup;
						  first := false
				      end
				 else begin
				        newpoly(t^.next);
						  t := t^.next
					   end;
		     t^.pcoef := nil;
			  t^.numb := p^.numb;
			  t^.exp := p^.exp;
		     if p^.numb
			    then begin
				        newimag(t^.ncoef);
						  t^.ncoef^.imag := nil;
				        complex_assign(p^.ncoef^, t^.ncoef^) 
					   end
			    else poly_assign(p^.pcoef, t^.pcoef);
			  p := p^.next
		  end;
		  
	   t^.next := nil;
	   free_poly(q);
	   q := dup
		  
	end;
	
 {*************************************************************************}
 
 procedure quoly_to_poly; { (q: quoly; var p: poly)}
 
    { q is a number and p is nil (or irrelevant), don't touch q. 
	  Convert to "poly number" format. }
	
	begin 
	 
	   newpoly(p);
	   p^.next := nil;
	   p^.exp := 0;
	   p^.numb := true;
	   newimag(p^.ncoef);
		p^.ncoef^.imag := nil;
		complex_assign(q^.ncoef^, p^.ncoef^)
		  
	end;
	
 {*************************************************************************}
 
 procedure poly_to_quoly; {(p: poly; var q: quoly)}
 
    { p is a number and q is nil, don't touch p. Convert to "quoly number" format. }
	
	begin
	 
	   newquoly(q);
	   q^.numb := true;
	   newimag(q^.ncoef);
		q^.ncoef^.imag := nil;
		complex_assign(p^.ncoef^, q^.ncoef^)  
	end;
	
 {*************************************************************************}
 
 procedure p_q_assign; {(p: poly; var q: quoly)}
 
    { p is converted to q.  p is read only. }
	
	begin
	
	   free_quoly(q);
	   if p^.numb and (p^.next = nil)
	      then poly_to_quoly(p, q)
		   else begin
		          newquoly(q);
		          q^.numb := false;
				    q^.numer := nil;
				    q^.denom := nil;
				    poly_assign(p, q^.numer)
			     end			
	   
    end;
 
 {************************************************************************}
 
 procedure polynum_to_quoly; {(var q: quoly)}
 
    { q is illegal quoly - its numer is a number, and its denom is nil. }
	
	var n: poly;
 
    begin
	
	   q^.numb := true;
	   n := q^.numer;
	   q^.ncoef := n^.ncoef;
	   n^.next := polygarb;
	   polygarb := n
	   
	end;
	   
 {*************************************************************************}
 
 procedure quoly_assign { (p: quoly; var q: quoly) };
    
	var dup: quoly;
 
    begin
	
	   newquoly(dup);
	   if p^.numb
	      then begin
				     newimag(dup^.ncoef);
					  dup^.ncoef^.imag := nil;
				     complex_assign(p^.ncoef^, dup^.ncoef^)
			     end
		  else begin
		          dup^.numer := nil;
				    dup^.denom := nil;
				    poly_assign(p^.numer, dup^.numer);
				    if p^.denom <> nil
				       then poly_assign(p^.denom, dup^.denom)
			   end;
	   dup^.numb := p^.numb;
	   free_quoly(q);
	   q := dup
	   
	end;
	
 {*************************************************************************}
 
 procedure poly_makeneg { (p: poly; var q: poly) };
 
    { q must be initialized }
 
    var dup, t: poly;
	    first: boolean;
 
    begin
	   
	   first := true;
	   while p <> nil do
	      begin
		     if first
			    then begin
				        newpoly(dup);
						  t := dup;
						  first := false
				      end
				else begin
				        newpoly(t^.next);
						  t := t^.next
					  end;
		     t^.pcoef := nil;
			  t^.numb := p^.numb;
			  t^.exp := p^.exp;
		     if p^.numb
			    then begin
				        newimag(t^.ncoef);
						  t^.ncoef^.imag := nil;
						  complex_makeneg(p^.ncoef^, t^.ncoef^)
					   end
			    else poly_makeneg(p^.pcoef, t^.pcoef);
			 p := p^.next
		  end;
		  
	   t^.next := nil;
	   free_poly(q); 
	   q := dup
		  
	end;
	
 {*************************************************************************}
 
 procedure quoly_makeneg { (p: quoly; var q: quoly) };
 
    var dup: quoly;
	
	begin
	
	   newquoly(dup);
	   if p^.numb
		  then begin
				   newimag(dup^.ncoef);
					dup^.ncoef^.imag := nil;
				   complex_makeneg(p^.ncoef^, dup^.ncoef^)
			    end
		  else begin
		          dup^.numer := nil;
				    dup^.denom := nil;
				    poly_makeneg(p^.numer, dup^.numer);
				    if p^.denom <> nil
				       then poly_assign(p^.denom, dup^.denom)
			   end;
	   dup^.numb := p^.numb;
	   free_quoly(q);
	   q := dup
	   
	end;

 {*************************************************************************}
 
 procedure check_and_assign; {(k: longint; var q: quoly)}
    { q nil or irrelevant on input }
	 var x: quolyptr;
    begin
	    x := @ arp[k shr 10]^[k and tenmask];
	    if x^ = nil
		    then begin
			         quoly_set(0, x^);
						writeln('Warning. Uninitialized array element has been set to 0.')
				   end;
		 q := x^
	 end;	 
	 
 {**************************************************************************}
 
 function poly_level; {(n: poly): longint}
 
    var k: longint; 
	 
	 begin
	 
	    if n^.numb
		    then if n^.next = nil
			         then poly_level := 0
						else poly_level := 1
		    else begin
			         k := 1;
						while not n^.numb and (n^.exp = 0) and (n^.next = nil) do
					      begin
						      n := n^.pcoef;
						      k := k + 1
					      end;
					   poly_level := k
					end
	 
	 end;
 
 {************************************************************************}
	
 procedure sub_expons; {(u: poly; var utail: poly; uexp: longint)}
 
    { last node in u has positive exponent, uexp. Subtract this from all nodes,
	   except maybe the last.  no laurents.  Pass back pointer to last node for 
		later restoration, but only if a number is encountered. else utail is
		undefined. }
	 
	 var pt: polyptrr;
	 
	 begin
	 
	    pt := @ u;
		 while pt^^.next <> nil do
	       begin
			    pt^^.exp := pt^^.exp - uexp;
				 pt := @ pt^^.next
			 end;
		 if pt^^.pcoef^.numb
		    then begin
			         utail := pt^;
						pt^ := utail^.pcoef
			      end
			 else pt^^.exp := 0  { = pt^^.exp - uexp }
	 
	 end;
  
 {************************************************************************}
	
 procedure restore_exps; {(u, utail: poly; uexp: longint)}
 
	 var pt: polyptrr;
	 
	 begin
	 
	    pt := @ u;
		 while pt^^.next <> nil do
	       begin
			    pt^^.exp := pt^^.exp + uexp;
				 pt := @ pt^^.next
			 end;
	    if pt^^.numb
		    then pt^ := utail
			 else pt^^.exp := uexp
	 
	 end;
 
  {********************************************************************}

  procedure free_sparse; {(var spar: sparseptr; dim: longint; arr_free: boolean)}
    
		var i, k, n: longint;
		    s, t: colm_ptr;
			 sp: sparseptr;
		
		begin
		
			 if not arr_free
			    then begin
				         spar := nil;
							exit {(free_sparse)}
					   end;
						
			 sp := spar;  {```}
			 n := (dim - 1) div sparsesize;
			 for k := 0 to n do
				 begin
					 for i := 1 + k*sparsesize to (k+1)*sparsesize do
						 if i > dim 
							 then break
						 else begin
								   s := sp^.indx[i-k*sparsesize];
								   t := s;
								   while s <> nil do
									   begin
										   free_quoly(s^.val);
										   t := s;
										   s := s^.next
									   end;
								   if t <> nil
									   then begin
												  t^.next := col_garb;
												  col_garb := sp^.indx[i-k*sparsesize]
											  end
							   end;
				    if k < n
					    then sp := sp^.next
				 end;
				 
			 sp^.next := spargarb;
			 spargarb:= spar;
			 spar := nil
			 
		end;
 
  {********************************************************************}

  procedure free_sparse_data(sp: sparseptr; dim: longint);  {```}
    
		var i, k: longint;
			 u, t: colm_ptrptr;
		
		begin
		
			 for k := 0 to (dim - 1) div sparsesize do
				 begin
					 for i := 1 + k*sparsesize to (k+1)*sparsesize do
						 if i > dim 
							 then break
						 else begin
								   u := @ sp^.indx[i-k*sparsesize];
									t := u;
								   while u^ <> nil do
									   begin
										   free_quoly(u^^.val);
										   u := @ u^^.next
									   end;
								   if t^ <> nil
									   then begin
												  u^^.next := col_garb;
												  col_garb := t^;
												  t^ := nil
											  end
							   end;
				    sp := sp^.next
				 end
			 
		end;
 
  {********************************************************************}

  procedure free_sparse_frame; {(var spar: sparseptr; dim: longint)}
    
		{ Leave the quolies untouched; somebody else owns them. Used only
		  for flipped sparses. }
		  
		var i, k, n: longint; 
		    s, t: colm_ptr;
			 sp: sparseptr;
		
		begin
		
			 sp := spar;  {```}
			 n := (dim - 1) div sparsesize;
			 for k := 0 to n do
				 begin
					 for i := 1 + k*sparsesize to (k+1)*sparsesize do
						 if i > dim 
							 then break
						 else begin
								   s := sp^.indx[i-k*sparsesize];
								   t := s;
								   while s <> nil do
									   begin
										   t := s;
										   s := s^.next
									   end;
								   if t <> nil
									   then begin
												  t^.next := col_garb;
												  col_garb := sp^.indx[i-k*sparsesize]
											  end
							   end;
				    if k < n
					    then sp := sp^.next
				 end;
				 
			 sp^.next := spargarb;
			 spargarb:= spar;
			 spar := nil
			 
		end;
 
	{*************************************************************************}
	 
	procedure purge_sparse; {(t: colm_ptrptr; c: longint)}  { Nov 1997 }
	   { value in row t and col c might be 0.  if so, delete it. 
	     It's ok if t^ = nil or entry c is not there. 
	     Note that c has already been corrected with addresser; we don't do that here.}
	   var s: colm_ptr;
	   begin
	     while t^ <> nil do
		     if c > t^^.coord
				  then t := @ t^^.next
			     else break;
		  if t^ = nil
		     then exit {(purge_sparse)};
		  if t^^.coord > c
		     then exit {(purge_sparse)};
		  if quoly_iszero(t^^.val)
		     then begin
		             s := t^^.next;
		             free_quoly(t^^.val);
		             t^^.next := col_garb;
		             col_garb := t^;
		             t^ := s
		          end
		end;
		  
	{*************************************************************************}
	 
	procedure sparse_zero_set; {(t: colm_ptrptr; c: longint; var qp: quolyptr)} 
	  { Nov 1997. Note that caller has corrected c for addresser and colflag; we don't 
	    check it here. }
	   var s: colm_ptr;
	   begin
	     while t^ <> nil do
		     if c > t^^.coord
				  then t := @ t^^.next
			     else break;
		  s := t^;
		  newcolm(t^);
		  t^^.next := s;
		  t^^.val := nil;
		  t^^.coord := c;
		  quoly_set(0, t^^.val);
		  qp := @ t^^.val
		end;
		  
   {*************************************************************************}
   
   procedure sparse_set; {(r, c: longint; q: arrptr; var qp: quolyptr; 
                           colflag: boolean)}
  
     { entry r,c is not in the sparse matrix, i.e. it was 0. We need to actually insert
	    it as 0, then change qp. 
	    
	    changed Nov 1997.  added colflag, Dec 1997.  }
		 
	  var t: colm_ptrptr;
	      sp: sparseptr;
			i: longint;
	  
	  begin
	  
	     r := r - addresser; 
		  c := c - addresser;
		  if colflag
		     then Inc(c)  
			  else begin { this all new! bug! April 1996}
				       c := 1 + r div q^.rows;
		             r := r mod q^.rows  
		          end;
		  sp := q^.spar;  {```}
		  for i := 1 to r div sparsesize do
			  sp := sp^.next;
		  t := @ sp^.indx[1 + r mod sparsesize];
		  sparse_zero_set(t, c, qp)
	  
	  end;
  
  {*************************************************************************}
	 
  procedure sparse_set_scalar; {(q: arrptr; cols: longint; n: quoly)```}
  
     var sp: sparseptr;
			i, j, k: longint;
			u: colm_ptrptr;
			
	  begin
	  
	     free_sparse_data(q^.spar, q^.rows);
		  if quoly_iszero(n)
		     then exit {(sparse_set_scalar)};
		  
		  sp := q^.spar;  {```}
		  for k := 0 to (q^.rows - 1) div sparsesize do
			  begin
				  for i := 1 + k*sparsesize to (k+1)*sparsesize do
					  if i > q^.rows 
						  then break
					  else begin
					          u := @ sp^.indx[i-k*sparsesize];
								 for j := 1 to cols do
								    begin
									    newcolm(u^);
					                u^^.coord := j;
					                u^^.val := nil;
										 quoly_assign(n, u^^.val);
									    u := @ u^^.next
									 end;
					          u^ := nil
					       end;
				  sp := sp^.next
			  end
	  	  
	  end;
  
  {**********************************************************************}
  
  procedure sparse_init; {(var spar: sparseptr; r: longint) ```}
  
     var sp: sparseptr;
	      j, k: longint;
	  
     begin
	  
	     newsparse(spar);
		  sp := spar;  
		  for k := 1 to (r - 1) div sparsesize do
			  begin
				  for j := 1 to sparsesize do
					  sp^.indx[j] := nil;
				  newsparse(sp^.next);
				  sp := sp^.next
			  end;
		  for j := 1 to 1 + (r - 1) mod sparsesize do
			  sp^.indx[j] := nil	
	  
	  end;  
  
  {*************************************************************************}
	
  procedure sparse_insert; {(r, c: longint; q: arrptr; colflag: boolean; var n: quoly)}
  
     { entry r,c is not in the sparse matrix, i.e. it was 0. We need to insert
	    it as n, unless n = 0. } 
		 
	  var t: colm_ptrptr; 
	      s: colm_ptr;
			sp: sparseptr;
			i: longint;
	  
	  begin
	  
	     if quoly_iszero(n)
		     then exit {(sparse_insert)};
			  
		  r := r - addresser;  
		  c := c - addresser;
		  if colflag
		     then Inc(c)  
			  else begin {@@@ this all new! bug! April 1996}
				       c := 1 + r div q^.rows;
		             r := r mod q^.rows  
		          end;
		  sp := q^.spar;  {```}
		  for i := 1 to r div sparsesize do
			  sp := sp^.next;
		  t := @ sp^.indx[1 + r mod sparsesize];
		  while t^ <> nil do
		     if t^^.coord < c
				  then t := @ t^^.next
			     else break;
		  s := t^;
		  newcolm(t^);
		  t^^.next := s;
		  t^^.val := nil;
		  t^^.coord := c;
		  quoly_assign(n, t^^.val)

	  end;
  
  {*************************************************************************}
	
  procedure isparse_insert; {(r, c: longint; n: longreal; q: arrptr; colflag, 
                     assign: boolean)}
    
     { insert n into q at spot r,c. q is known sparse. assign means n is to be
       assigned, else it's to be incremented. Nov 1997 } 
		 
	  var t: colm_ptrptr; 
	      s: colm_ptr;
			sp: sparseptr;
			k: longreal;
			i: longint;
	  
	  procedure delete_it;
	     begin
	        s := t^;
		     t^ := s^.next;
		     free_quoly(s^.val);
		     s^.next := col_garb;
		     col_garb := s
	     end;
	     
	  procedure stash_it;
	     begin
		     s := t^;
		     newcolm(t^);
		     t^^.next := s;
		     t^^.val := nil;
		     quoly_set_ext(n, t^^.val);
		     t^^.coord := c
	     end;
	     
	  procedure store_n;
	     begin
	        with t^^.val^.ncoef^ do
	           float := n
	     end;
	     
	  procedure retrieve_k;
	     begin
	        with t^^.val^.ncoef^ do
	           k := float
	     end;
	     
	  begin
	  
		  r := r - addresser;  {@@@ remove +1}
		  c := c - addresser;
		  if colflag
		     then Inc(c)  
			  else begin {@@@ this all new! bug! April 1996}
				       c := 1 + r div q^.rows;
		             r := r mod q^.rows  
		          end;
		  sp := q^.spar;  
		  for i := 1 to r div sparsesize do
			  sp := sp^.next;
		  t := @ sp^.indx[1 + r mod sparsesize];
		  while t^ <> nil do
		     if t^^.coord < c
				  then t := @ t^^.next
			     else break;
		  if (t^ = nil) and (t^^.coord > c) { not there }
		     then if n = 0
		             then { nothing }
		             else stash_it
	     else if n = 0
	             then if assign
	                     then delete_it
	                     else { nothing }
	     else if assign
                then store_n
                else begin
                        retrieve_k;
                        n := k + n;
                        if n = 0
                           then delete_it
                           else store_n
                     end

	  end;
  
  {*************************************************************************}
  
  procedure sparse_delete; {(r, c: longint; q: arrptr; colflag: boolean;)}
  
     { entry r,c IS in the sparse matrix. We need to delete it. } 
		 
	  var t: colm_ptrptr; 
	      s: colm_ptr; 
			i: longint;
			sp: sparseptr;
	  
	  begin
	  
	     r := r - addresser;  
		  c := c - addresser;
		  if colflag
		     then Inc(c)  
			  else begin {@@@ this all new! bug! April 1996}
				       c := 1 + r div q^.rows;
		             r := r mod q^.rows  
		          end;
		  sp := q^.spar;
		  for i := 1 to r div sparsesize do
			  sp := sp^.next;
		  t := @ sp^.indx[1 + r mod sparsesize];
		  while true do
		     if t^^.coord < c
				  then t := @ t^^.next
			     else break;
		  s := t^;
		  t^ := s^.next;
		  free_quoly(s^.val);
		  s^.next := col_garb;
		  col_garb := s
	  
	  end;
  
 {*************************************************************************}
 
 procedure scalar_to_poly { var n: number; var p: poly };
 
    { n and d are used up by this procedure and get attached to p.
	  DO NOT REFER AGAIN TO N ! }
 
    begin
	
	   free_poly(p);
	   newpoly(p);
	   p^.next := nil;
	   p^.exp := 0;
	   p^.numb := true;
	   newimag(p^.ncoef);
	   p^.ncoef^.float := n.float;
		p^.ncoef^.imag := n.imag
	   
	end;
	
 {*************************************************************************}
 
 procedure scalar_to_quoly { var n: number; var p: quoly };
 
    { n and d are used up by this procedure and get attached to p.
	  DO NOT REFER AGAIN TO N ! }
 
    begin
	
	   free_quoly(p);
	   newquoly(p);
	   p^.numb := true;
	   newimag(p^.ncoef);
	   p^.ncoef^.float := n.float;
		p^.ncoef^.imag := n.imag
	   
	end;
	
 {*************************************************************************}

  function convert_to_int; {(var n: number): longint;}

	 {   Return neg_two_to_31 if no good.
	     Imaginary parts ignored. 
	     Note difference between floatmode and others, as to very large numbers. }

      begin
		
		   if trunc(n.float) <> n.float  { not an integer }
			   then convert_to_int := neg_two_to_31
			   else convert_to_int := trunc(n.float)
				
      end;
			
 {************************************************************************}
 
 function quoly_convert_to_int { (p: quoly): longint };
 
    var q: poly;
 
    begin
	
	   if not p^.numb
	      then begin
		          q := p^.numer;
				    while not q^.numb do { sink }
	                 q := q^.pcoef;
				    quoly_convert_to_int := round(q^.ncoef^.float)
			     end		  
	      else quoly_convert_to_int := round(p^.ncoef^.float)
	   
	end;

 {************************************************************************}
 
 function spec_convert_to_int { (p: quoly): longint };
 
    var q: poly;
 
    begin
	
	   if not p^.numb
	      then begin
		          q := p^.numer;
				    while not q^.numb do { sink }
	                 q := q^.pcoef;
				    spec_convert_to_int := convert_to_int(q^.ncoef^)
			     end		  
	      else spec_convert_to_int := convert_to_int(p^.ncoef^)
	   
	end;

 {*************************************************************************}
 
 function poly_length { (n: poly): longint} ;
 
    var m: longint;
	
	begin
	
	   m := 0;
	   while n <> nil do
	      begin
		     m := m + 1;
			  n := n^.next
		  end;
		  
	   poly_length := m
		  
	end;
	
 {**************************************************************************}
	
 function maxx; {(a, b: integer): integer}
	 begin
		 if a > b
			 then maxx := a
			 else maxx := b
	 end;
					 
 {***************************************************************************}
	
  function depth_below; {(p: poly): integer}
  
	  { laurent ok.  depth below p.  fer218 has a quick_depth_below. }
	  
	  var d: integer;
	 
	  begin
		  d := 0; 
		  while p <> nil do
			  begin
				  if not p^.numb
					  then d := maxx(d, 1 + depth_below(p^.pcoef));
				  p := p^.next
			  end;
		  depth_below := d
	  end;	 
	 
 {******************************************************************************}
 
 function poly_height; {(p: poly): integer;}
		 
	 { laurent ok. maximum difference in depth anywhere in p }
	 	 
	 begin
	 
		 { ignore leading dummy nodes }
		 while not p^.numb do
			 if (p^.exp = 0) and (p^.next = nil)
				 then p := p^.pcoef
				 else break;
		 poly_height := depth_below(p)
			
	 end;
			 
 {************************************************************************}
 
 function poly_eq_pm1(p: poly): boolean;
 
    var y: boolean; 
 
    begin 
	
	    if p^.numb and (p^.next = nil)
	       then poly_eq_pm1 := equal_to_pm1(p^.ncoef^, y) and (p^.ncoef^.imag = nil)
		    else poly_eq_pm1 := false
		  
	  end;
	
 {*************************************************************************}
 
 function poly_small { (n: poly): boolean};
 
    { Used by quoly_display. Subtle. Want the user to be able to enter the displayed
		line. }
 
	 begin
	
	   if n^.numb 
		   then if n^.next = nil
				     then poly_small := not complex or (n^.ncoef^.imag = nil) or (n^.ncoef^.float = 0)
					  else poly_small := false
			else if n^.exp = 0
	              then poly_small := poly_small(n^.pcoef)
		           else poly_small := (n^.next = nil) and poly_eq_pm1(n^.pcoef)
	   
	end;
	
 {*************************************************************************}
 
 procedure poly_to_scalar { (p: poly, var n: number) };
 
    { assume that p is a number. p is left untouched }
  
    begin
	
	   complex_assign(p^.ncoef^, n)
	   
	end;
	
 {*************************************************************************}
 
 procedure quoly_to_scalar { (p: quoly, var n: number) };
 
    { assume that p is a number. p is left untouched }
  
    begin
	
	   complex_assign(p^.ncoef^, n)
	   
	end;
	
 {*************************************************************************}
 
 procedure poly_conjugate { p: poly };
 
    begin
	   
	   while p <> nil do
	      begin
		     if p^.numb
			    then conjugate(p^.ncoef^, p^.ncoef^)
			    else poly_conjugate(p^.pcoef);
			 p := p^.next
		  end
		  
	end;
	
 {*************************************************************************}
 
 function poly_mass(n: poly; depth: longint): longint;
 
    var m: longint;
	
	begin
	
	   m := 0;
	   while n <> nil do
	      begin		     
		     if n^.numb
			     then m := m + 1
			  else if n^.exp <> 0
			     then m := m + abs(n^.exp)*10*depth*poly_mass(n^.pcoef, depth - 1)
			  else m := m + poly_mass(n^.pcoef, depth - 1);
			  n := n^.next
		  end;
		  		  
	   if m < 0  { fail safe in case of integer overflow above } 
	      then m := block;
		  
	   poly_mass := m 
		  
	end;
	
 {*************************************************************************}
 
 function quoly_mass { (n: quoly): longint };
 
    begin
	   
	   if n^.numb
	      then quoly_mass := 1
	   else if n^.denom = nil
	      then quoly_mass := poly_mass(n^.numer, number_polys)
	   else quoly_mass := poly_mass(n^.numer, number_polys) + 
	                      massnum * poly_mass(n^.denom, number_polys)
 
    end;
 
 {*************************************************************************} 
 
 function is_array_param; {(p: quoly): boolean}
 
    begin
	
	   if p^.numb 
	      then if p^.ncoef^.size = -1742
		           then is_array_param := true
				     else is_array_param := false
	      else is_array_param := false
	
	end;
	
 {*************************************************************************}

 function is_poly_name { x: nametype; var depth: longint : boolean }; 
 
    var q: polypt;
 
    begin
	
	   is_poly_name := false;
	   depth := 1;
	   q := polynames;
	   while q<>nil do
		  if q^.let.name = x
		     then begin
				     is_poly_name := true;
				     exit {(is_poly_name)}
				  end
			 else begin
			         q := q^.next;
					   depth := depth + 1
				  end
			 
    end;
 
 {*************************************************************************}

 function its_a_polyname { x: nametype }; 
 
    var i: integer;
 
    begin
	
	   for i := 1 to number_polys do
		   if x < polyvar[i]
			   then begin
				        its_a_polyname := false;
						  exit {(its_a_polyname)}
					  end
		   else if x = polyvar[i]
			   then begin
				        its_a_polyname := true;
						  exit {(its_a_polyname)}
					  end;
					  
	   its_a_polyname := false
			 
    end;
 
 {*************************************************************************}

 procedure is_poly_name2 {(x: nametype; var depth: longint; var q: polypt) }; 
 
    begin
	
	   depth := 1;
	   q := polynames;
	   while q <> nil do
		   if q^.let.name = x
		      then exit {(is_poly_name2)}
			   else begin
			           q := q^.next;
					     depth := depth + 1
				     end
			 
    end;
 
 {*************************************************************************}
 
 procedure delete_poly_name; { (depth: longint) }
 
    { This procedure throws away polydata nodes. }
 
    var i: longint;
	    q: polypt;
	
	begin
	
	   if depth = 1
	      then polynames := polynames^.next
	   else begin
	           q := polynames;
	           for i := 1 to depth - 2 do
			       q := q^.next;
			     q^.next := q^.next^.next
			  end
			
    end;
	
 {************************************************************************}
 
 function quoly_convert_to_ext { (p: quoly): longreal };
 
    var q: poly;
 
    begin
	
	   if not p^.numb
	      then begin
		          q := p^.numer;
				    while not q^.numb do { sink }
				       q := q^.pcoef;
				    quoly_convert_to_ext := q^.ncoef^.float
			     end		  
	      else quoly_convert_to_ext := p^.ncoef^.float
	   
	end;

 {*************************************************************************}
 
 procedure quoly_convert_to_comp; { (p: quoly; var x, y: longreal) }
 
    var q: poly;
	
	 begin
 
       if not p^.numb
	      then begin
		          q := p^.numer;
				    while not q^.numb do { sink }
				       q := q^.pcoef;
				    x := q^.ncoef^.float;
				    if q^.ncoef^.imag = nil
				       then y := 0
					    else y := q^.ncoef^.imag^.float
			   end		  
	      else begin
		          x := p^.ncoef^.float;
				    if p^.ncoef^.imag = nil
				       then y := 0
					    else y := p^.ncoef^.imag^.float
			   end
 
    end;
	
 {*************************************************************************}
 
 procedure remove_one(var p: poly; depth: longint);
 
    { Used after deleting a poly var, to purge dummy place-holding nodes that
	  correspond to the now defunct variable. }
	  
	var q: poly;
 
    begin
	
	   if depth = 1   { trivial case }
	      then if not p^.numb { it must point to a dummy place-holding node }
		          then begin
				           q := p^.pcoef;
						     p^.pcoef := nil;
						     free_poly(p);
						     p := q
					      end
				    else
	   else begin
	           q := p;
			     while q <> nil do
			       begin
				      if not q^.numb
					      then remove_one(q^.pcoef, depth - 1);
					   q := q^.next
				    end
			end					 
	   
	end;
	
 {*************************************************************************}
 
 procedure remove_poly_var; {(var q: quoly; depth: longint)}
 
    begin
	
	   if not q^.numb
	      then begin
		          remove_one(q^.numer, depth);
				    if q^.denom <> nil
				      then remove_one(q^.denom, depth)
			     end
			   
    end;	          

 {************************************************************************}
	
 procedure base_poly { var p: poly; depth: longint };
 
    var i: longint;
	    t: poly;
 
    begin
	
	   free_poly(p);
	   for i := 1 to depth + 1 do
	      begin
		     if i=1 
			    then begin
				        newpoly(p);
						  t := p
				     end
			 else begin
			         newpoly(t^.pcoef);
					   t := t^.pcoef
				  end;
			 t^.numb := (i = depth + 1);
			 t^.next := nil;
			 if i = depth
			    then t^.exp := 1
				 else t^.exp := 0;
		  end;
	   newimag(t^.ncoef);
	   t^.ncoef^.float := 1;
		t^.ncoef^.imag := nil
	
	end;
	
 {************************************************************************}
	
 procedure base_quoly { var p: quoly; depth: longint };
 
    begin
	  
	   free_quoly(p);
	   newquoly(p);
	   p^.numb := false;
	   p^.denom := nil;
	   p^.numer := nil;
	   base_poly(p^.numer, depth)
 
    end;
 
 {*************************************************************************}
 
 function node_total { (n: poly): longint} ;
 
    var m: longint;
	
	begin
	
	   m := 0;
	   while n <> nil do
	      begin
		      m := m + 1;
				if not n^.numb
				   then m := m + node_total(n^.pcoef);
			   if m > 12
				   then break;
			   n := n^.next
		   end;
		  
	   node_total := m
		  
	end;
	
 {*************************************************************************}
 
 function poly_equal { (p,q: poly): boolean };
 
    { assumes no negative denominators in rational mode. }
 
    var test: boolean;
	
	begin
	   
	   poly_equal := false;
	   test := true; 
	   while p <> nil do
	      begin
		     if q = nil then exit {(poly_equal)};
		     if p^.numb
			    then if q^.numb
				        then test := complex_equal(p^.ncoef^, q^.ncoef^)								 
					     else exit {(poly_equal)}
				else if q^.numb
				        then exit {(poly_equal)}
						  else test := (p^.exp = q^.exp ) and poly_equal(p^.pcoef, q^.pcoef);
			 if test
			    then
				 else exit {(poly_equal)};
			 p := p^.next;
			 q := q^.next
		  end;
		  
	   poly_equal := (q = nil)
		  
	end;
	
 {*************************************************************************}	   

 procedure poly_imag_free { (var p: poly)} ;
 
    var q,t: poly;
	
	procedure remove;	
	   begin
	      if t = nil
		     then begin
			         p := q^.next;
					   q^.next := nil;
					   free_poly(q);
					   q := p
				    end
			  else begin
						 t^.next := q^.next;
						 q^.next := nil;
						 free_poly(q);
						 q := t^.next
					 end
       end;
 
    begin
	   
	   q := p;
	   t := nil;
	   while q <> nil do
	      begin
		     if q^.numb
			     then imag_free(q^.ncoef^) 
			     else poly_imag_free(q^.pcoef);
			  if q^.numb
			    then if node_iszero(q)
				        then remove
						  else begin
						         t := q;
								   q := q^.next
						       end
				 else if poly_iszero(q^.pcoef)
				         then remove
			            else begin
						          t := q;
								    q := q^.next
						        end
		   end;
	   if p = nil
	      then poly_set(0, p)
		  
	end;
		
 {*************************************************************************}	   

 procedure poly_imag_part { (var p: poly)} ;
 
    var q,t: poly;
	
	procedure remove;	
	   begin
	      if t = nil
		     then begin
			         p := q^.next;
					   q^.next := nil;
					   free_poly(q);
					   q := p
				    end
		  else begin
		          t^.next := q^.next;
				    q^.next := nil;
				    free_poly(q);
				    q := t^.next
			    end
       end;
 
    begin
	   
	   q := p;
	   t := nil;
	   while q <> nil do
	      begin
		     if q^.numb
			     then imag_part(q^.ncoef^) 
			     else poly_imag_part(q^.pcoef);
			  if q^.numb
			     then if node_iszero(q)
				         then remove
						   else begin
						          t := q;
								    q := q^.next
						        end
				else if poly_iszero(q^.pcoef)
				         then remove
			            else begin
						           t := q;
								     q := q^.next
						        end
		  end;
	   if p = nil
	      then poly_set(0, p)
		  
	end;
		
 {*************************************************************************}
 
 function essentially_equal { (p, q: poly): boolean };
 
   { Are p and q equal, or is one an invertible element of the ground ring times
	  the other?  Works for all modes and complex. }

	function check_all(p, q: poly) : boolean; {wwh}
	   var test: boolean;
		begin
      check_all := false;
      test := false;
		   while p <> nil do
				begin
				  if q = nil then exit {(essentially_equal)};
				  if p^.numb
					  then if q^.numb
								 then test := complex_equal(p^.ncoef^, q^.ncoef^)
								 else exit {(essentially_equal)}
					  else if q^.numb
								 then exit {(essentially_equal)}
								 else begin
											test := (p^.exp = q^.exp);
											if test 
												then check_all := check_all(p^.pcoef, q^.pcoef)
										end;
				  if not test
					  then exit {(essentially_equal)};
				  p := p^.next;
				  q := q^.next
			   end;

			if q = nil then  check_all := true
			{if q <> nil
			   then exit {(essentially_equal)}
		end;

	begin

	    essentially_equal := false;

		 if not complex_equal(leading_coef(p)^.ncoef^, leading_coef(q)^.ncoef^)
			 then exit {(essentially_equal)};

		 essentially_equal := check_all(p, q);

	end;
	
 {*************************************************************************}
 
 function quoly_equal { (p,q: quoly): boolean };
 
    { assumes no negative denoms of numbers in rational mode. }
	 { assumes canonical forms! }
 
	begin
	
	   quoly_equal := false;
	   if p^.numb
		  then if q^.numb
				  then quoly_equal := complex_equal(p^.ncoef^, q^.ncoef^)						 
				  else exit {(quoly_equal)}
	   else if q^.numb
			   then exit {(quoly_equal)}
	   else if p^.denom = nil
	           then if q^.denom = nil
	                   then quoly_equal := poly_equal(p^.numer, q^.numer)
					       else exit {(quoly_equal)}
	   else if q^.denom = nil
	           then exit {(quoly_equal)}
	   else quoly_equal := poly_equal(p^.numer, q^.numer) and poly_equal(p^.denom, q^.denom)

    end;	
	
 {***********************************************************************}
 
 function poly_iszero { (p: poly): boolean };
 
    begin
	
	   if p^.numb and (p^.next = nil)
	      then poly_iszero := iszero(p^.ncoef^)
		   else poly_iszero := false
		  
	end;
	
 {***********************************************************************}
 
 function node_iszero { (p: poly): boolean };
 
    begin
	
	   if p^.numb 
	      then node_iszero := iszero(p^.ncoef^)
		   else node_iszero := false
		  
	end;
	
 {*************************************************************************}
 
 function pos_leading_coef { (p: poly): boolean };
 
    { is the leading coef positive? only used by poly_display. }
 		 
   begin
	
	   if p^.numb 
	      then if complex
					  then if p^.ncoef^.float = 0
							    then if p^.ncoef^.imag <> nil
										   then pos_leading_coef := (p^.ncoef^.imag^.float > 0)
										   else pos_leading_coef := false
							    else pos_leading_coef := (p^.ncoef^.float > 0)
									  
					  else pos_leading_coef := (p^.ncoef^.float > 0)
	      else pos_leading_coef := pos_leading_coef(p^.pcoef)
	
	end;
	
 {************************************************************************}
 
 function poly_eq_1; { (p: poly): boolean }
  
    begin
	
	   if p^.numb and (p^.next = nil)
	      then poly_eq_1 := (p^.ncoef^.float = 1) and (p^.ncoef^.imag = nil)
		   else poly_eq_1 := false
		  
	end;
	
 {***********************************************************************}
 
 function quoly_iszero { (p: quoly): boolean };
 
    begin
	
	   if p^.numb
	      then quoly_iszero := iszero(p^.ncoef^)
		   else quoly_iszero := false
		  
	end;
	
 {************************************************************************}
 
 function quoly_eq_1; { (p: quoly): boolean }
  
    begin
	
	   if p^.numb
	      then quoly_eq_1 := (p^.ncoef^.float = 1) and (p^.ncoef^.imag = nil)
		   else quoly_eq_1 := false
		  
	end;
	
 {************************************************************************} 
 
 function pos_imag_part {(p: poly): boolean} ;
 
    { Is the number p purely imaginary with positive imag part? }
 
    var t, x: imptr;
 
    begin
	
	   x := p^.ncoef;
	   pos_imag_part := false;
	   if x^.imag <> nil
	      then begin
	              t := x^.imag;
			        x^.imag := nil;
			        if iszero(x^)
			           then pos_imag_part := (t^.float > 0);
				     x^.imag := t
			    end
			   
    end;
	
 {***********************************************************************}

 function poly_depth { (p: poly): integer } ;
 
    var ans: integer;
 
    begin
	
	   if p^.numb
	      then begin
		          if p^.next = nil
		             then poly_depth := halfblock  { 'infinity' }
				       else poly_depth := 1;  { a Laurent poly }
				  exit {(poly_depth)}
			   end
		  else ans := 1;
		  
	   while (p^.exp = 0) and (p^.next = nil) do
	      begin
		      ans := ans + 1;
			   p := p^.pcoef
		   end;
		  
	   poly_depth := ans
		  
   end;
   
 {***********************************************************************}
 
 function height_is_1; { (n: poly): boolean }
 
    begin
	
	   height_is_1 := false;
	   while n <> nil do
	      begin
		     if not n^.numb
			    then if not n^.pcoef^.numb
				         then exit {(height_is_1)};
			  n := n^.next
		  end;
	   height_is_1 := true  		
		  
	end;
	
{***********************************************************************}
 
 procedure findHeight; { (var n, m: poly; var h: integer) }
 
	begin
	
	   h := 0;
	   while (n^.exp = 0) and (m^.exp = 0) do
	      begin
		     n := n^.pcoef;
			  m := m^.pcoef;
			  h := h + 1
		   end
		     
    end;
 
 {*********************************************************************}
 
 function leading_coef; { (n: poly): poly }
 
    { NOTE: in laurent, n is not necessarily pointing to a poly that is ONLY
	  a number!  Outside laurent, it is. }
 
    begin
	
	   while not n^.numb do
	      n := n^.pcoef;
	   leading_coef := n  
	  
	end;
	
 {**************************************************************************}
 
 procedure quoly_consume; {(var n: quoly; var p: poly)}
 
    { convert number n to poly format by consuming n. p is nil or irrelevant.  }
 
    begin
	
	   newpoly(p);
	   p^.next := nil;
	   p^.exp := 0;
	   p^.numb := true;
	   p^.ncoef := n^.ncoef;
	   n^.next := quolygarb;
      quolygarb := n;
	   n := nil
	   
	end;
	 
 {**************************************************************************}
 
 procedure poly_consume; {(var n: poly; var q: quoly)}
 
    { convert number n to quoly format by consuming n. q must be nil or irrelevant.}
 
    begin
	
	   newquoly(q);
	   q^.numb := true;
	   q^.ncoef := n^.ncoef;
	   n^.next := polygarb;
      polygarb := n;
	   n := nil
	   
	end;
	 
 {*************************************************************************}
 
 procedure initialize;
 
    var i: longint;
 
    begin
	   
	   subinitialize;
	   
	   new(syst);  { system's array } 
		with syst^ do  {```  }
		   begin
			   start := 0;
				stop := -1;
				size := 0;
				rows := 0;
				next := nil; 
				spar := nil;
				name.name := chr(17) { Sep 2002 }
		   end;
		syst_dump := false;  { syst array hasn't been changed so don't display it. }
		new(stash);
		for i := 0 to arr_limit - 1 do  { initialize space for syst }
		   stash^[i] := nil;

		polygarb := nil;
	   quolygarb := nil;
	   polynames := nil;
	   number_polys := 0;
	   cutoff := 10;
	   quol_num_0 := nil;
		quoly_set(0, quol_num_0);
		quoly_set(0, prevnum)
	   
	end;
	
 {****************************************************************************}
	
 procedure copy_sparse; { var s, t: sparseptr; dim: longint; neg: boolean }
 
	 { t is assumed to be nil, or at least never assigned anything. }
	 
	 var i, k, n: longint;
		  u, v: colm_ptr;
		  sp, sp2: sparseptr;
	
	 begin
	
		 sp := s;  {```}
		 for k := 0 to (dim - 1) div sparsesize do
			 begin
				 if k = 0
					 then begin
								newsparse(t);
							   sp2 := t
							end
					 else begin
								newsparse(sp2^.next);
								sp2 := sp2^.next
							end;
				 for i := 1 + k*sparsesize to (k+1)*sparsesize do
					 if i > dim 
						 then break
					 else begin
								 n := i - k*sparsesize;
								 u := sp^.indx[n];
								 if u = nil
									 then sp2^.indx[n] := nil
									 else begin
												newcolm(sp2^.indx[n]);
												v := sp2^.indx[n];
												v^.val := nil;
												if neg
													then quoly_makeneg(u^.val, v^.val)
													else quoly_assign(u^.val, v^.val);
												v^.coord := u^.coord;
												u := u^.next;
												while u <> nil do
													begin
														newcolm(v^.next);
														v := v^.next;
														v^.val := nil;
														if neg
															then quoly_makeneg(u^.val, v^.val)
															else quoly_assign(u^.val, v^.val);
														v^.coord := u^.coord;
														u := u^.next
													end;
												v^.next := nil
											end
							end;
				sp := sp^.next
		  end
		 
	end;
 
 {****************************************************************************}
 
 procedure sparse_makeneg; {(var spar: sparseptr; rows: longint; var arr_free: boolean)}
 
    var sp: sparseptr;
	     u: colm_ptr;
	     i, k: longint;
	 
	 begin
	 
	    sp := spar;  {```}
		 if arr_free
		    then for k := 0 to (rows - 1) div sparsesize do
						 begin
							 for i := 1 + k*sparsesize to (k+1)*sparsesize do
								 if i > rows 
									 then break
								 else begin
											u := sp^.indx[i-k*sparsesize];
											while u <> nil do
												begin
													quoly_inplace(u^.val);
													u := u^.next;
												end
										end;
							 sp := sp^.next
						 end
			 else begin
			         copy_sparse(spar, sp, rows, true);
						spar := sp
				   end;
			 
		arr_free := true
		
	 end;
 
 {****************************************************************************}
 
 procedure spar_identi; {(var spar: sparseptr; rows: longint; arr_free: boolean)}
 
    var u: colm_ptr;
	     i, k: longint;
		  sp: sparseptr;
	 
	 begin

	    free_sparse(spar, rows, arr_free);     {```}
		 
		 for k := 0 to (rows - 1) div sparsesize do
			  begin
				  if k = 0
					  then begin
								 newsparse(spar);
								 sp := spar
							 end
					  else begin
								 newsparse(sp^.next);
								 sp := sp^.next
							 end;
				  for i := 1 + k*sparsesize to (k+1)*sparsesize do
					  if i > rows 
						  then break
					  else begin
								 newcolm(sp^.indx[i-k*sparsesize]);
								 u := sp^.indx[i-k*sparsesize];
								 u^.coord := i;
								 u^.next := nil;
								 u^.val := nil;
								 quoly_set(1, u^.val)
							 end;
				  sp := sp^.next
			  end

	 end;
  
 {****************************************************************************}
	
 procedure switchrow_col; { (index, j, k, start, total_rows, target_rows, cols
                             : longint); }
							 
	{ k and j are normalized }
 
    var increm, i: longint;
	    temp: quoly;
	 
	begin
	
	  if index = Switchrow_  
	     then begin
	             j := j + start;
                k := k + start;
				    increm := total_rows;
				    start := cols
			    end
		 else begin { switchcol }
			     j := j*total_rows + start;
				  k := k*total_rows + start;
				  increm := 1;
				  start := target_rows
			   end;
	  for i := 0 to start - 1 do
         begin
				 temp := arp[j shr 10]^[j and tenmask];
				 arp[j shr 10]^[j and tenmask] := arp[k shr 10]^[k and tenmask];
				 arp[k shr 10]^[k and tenmask] := temp;
				 j := j + increm;
				 k := k + increm
         end
		 
   end;

 {*****************************************************************************}
 
 procedure fillup; { (rows, cols, start: longint; var arr: workarray); }
 
    { Fills up newly created array with stuff from arr, which is newly created. }
 
    var i, j, k, locat: longint;
	
	begin
	
	   j := 0;
	   for i := 0 to cols - 1 do
	      for k := 0 to rows - 1 do
             begin
		          locat := start + k + i*rows;
                arp[locat shr 10]^[locat and tenmask] := arr[j];
                j := j + 1
             end
			 
    end;
	
 {************************************************************************}
 
 procedure findbest; { (start, stop, rows, i: longint; var j, k: longint); }
 
      { i, j and k are relative coordinates with (0,0) base, rows = total number
	    of rows in matrix.  start and stop are absolute coords in arp. 
		    doesn't consider complex numbers very well. }
 
      label 876;
	  
	  var spot, maybe_pol, maybe_num, best, t: longint;
	      p, q: quoly;
							    
      begin
	  
		spot := start + i + i*rows;  { an absolute address within the store }
		maybe_pol := -1;
		maybe_num := -1;
		best := -1;
      while spot <= stop do
		   begin
		      for t := spot to spot + rows - i - 1 do
			     begin
				    p := arp[t shr 10]^[t and tenmask];
                if quoly_iszero(p)    
			          then { nothing }
					 else if p^.numb
								 then begin
											best := t;
											goto 876
										end
				    else if maybe_pol = -1  
					        then maybe_pol := t
							  else begin
							          q := arp[maybe_pol shr 10]^[maybe_pol and tenmask];
							          if quoly_mass(p) < quoly_mass(q)
									       then maybe_pol := t
								    end
				 end;
			  spot := spot + rows
		   end;
		   
		876:;
		
		if best = -1
		   then if maybe_num > -1
		           then best := maybe_num
		           else if maybe_pol > -1
				             then best := maybe_pol;
				   
	   if best = -1
		   then j := -1
		   else begin
		           best := best - start;
		           j := best mod rows;
				     k := best div rows
				  end
		   
      end;
			
  {***************************************************************************}

  function better_number; {(var n1, n2: number): boolean; }
	
	   { heuristics for better number for find_good_spot. Is n2 better than n1?
		  Neither is 0. If both real, which is closer in absolute value to 1?
		  moved here Oct 2000 to use in colfindbest too. }
		 
		 begin
		 
			  if (n1.imag = nil) and (n2.imag = nil)
				   then better_number := ( abs(abs(n2.float) - 1) < abs(abs(n1.float) - 1) )
			  else if n1.imag = nil
				   then better_number := false
			  else if n2.imag = nil
				   then better_number := true
			  else better_number :=  abs(abs(n2.float) - 1) + abs(n2.imag^.float)  < 
				                      abs(abs(n1.float) - 1) + abs(n1.imag^.float)
								 
		 end;

  {***************************************************************************}

  function close_to_0; {(var n1: number): boolean; }
	
	   { is n1 close to 0?  Oct 2000 }
		 
		 begin
		 
			  if n1.imag = nil
				  then close_to_0 := (abs(n1.float) < 1e-6 )
			  else close_to_0 :=  (abs(n1.float) + abs(n1.imag^.float) < 2e-6);
								 
		 end;

 {*************************************************************************}
 
 procedure colfindbest; { (start, rows, i, col: longint; var j: longint);  
                           Oct 2000 }
 
    { i, col, j are relative coordinates with (0,0) base, rows = total number
	    of rows in matrix.  start and stop are absolute coords in arp. 
	    Return j, the row number of the best spot in column col, from row i on down.  
	    We do not look in any other column but col. }
	  
	  var spot, maybe_pol, maybe_num, best, t: longint;
	      q: quoly;
	      p: quolyptr;
		   either: boolean; 
							    
    begin
	  
		spot := start + i + col*rows;  { an absolute address within the store }
		maybe_pol := -1;
		maybe_num := -1;
		best := -1;
      for t := spot to spot + rows - i - 1 do
	      begin
			   p := @ arp[t shr 10]^[t and tenmask];
           { if p^^.numb
				   then if close_to_0(p^^.ncoef^)
							  then quoly_set(0, p^);  gave up on this idea }
		      if quoly_iszero(p^)    
		         then { nothing }
            else if p^^.numb
			        then if equal_to_pm1(p^^.ncoef^, either)
			                then begin
						               best := t;
								         break
								      end
								 else if maybe_num = -1
										   then maybe_num := t
										   else begin
													  q := arp[maybe_num shr 10]^[maybe_num and tenmask];
													  if better_number(q^.ncoef^, p^^.ncoef^)
														  then maybe_num := t
												  end
			      else if maybe_pol = -1  
				          then maybe_pol := t
						    else begin
						            q := arp[maybe_pol shr 10]^[maybe_pol and tenmask];
						            if quoly_mass(p^) < quoly_mass(q)
								         then maybe_pol := t
							       end
		    end;
		
		 if best = -1
		   then if maybe_num > -1
		           then best := maybe_num
		           else if maybe_pol > -1
								 then best := maybe_pol;
				   
	   if best = -1
		    then j := -1
		    else j := (best - start) mod rows
		   
   end;
			
 {************************************************************************}

  procedure swap_rows; {(var n: quoly; var dup: workarray; want_n, do_all: boolean; 
                         i, j, m: longint);}
											
	  { m = rows; i and j reduced coordinates. Assume i <> j. }

      var k, s: longint;
          temp: quoly;

      begin
        for k := 0 to m-1 do
          begin
            s := m * k;
            if do_all or (k >= i)
					then begin
							temp := dup[i+s];
							dup[i+s] := dup[j+s];
							dup[j+s] := temp
						end;
          end;
        if want_n
           then quoly_inplace(n)
      end;
			
  {***************************************************************************}
  
  procedure swap_cols; {(var arr: workarray; i, j, rows: longint);}
  
      var k, s, t: longint;
          temp: quoly;

      begin
	     s := j*rows;
		  t := i*rows;
        for k := 0 to rows-1 do
           begin
			     temp := arr[t+k];
			     arr[t+k] := arr[s+k];
			     arr[s+k] := temp;
           end	 
	  end;
	 			  
 {**************************************************************************}
 
 procedure identi; {(var arr: workarray; rows: longint; arr_free: boolean);}
 
    var i,j,k: longint;  
		
	  begin
		
		 for i := 1 to rows do
		  for j := 1 to rows do
			 begin
				k := i + rows * (j - 1) - 1;
				if not arr_free  
				   then arr[k] := nil;
				if i = j
				   then quoly_set(1, arr[k])
				   else quoly_set(0, arr[k])
			 end
						 
	  end;
		

 end.