unit ferm118;
 

 interface


//USES {Types,} {QuickDraw,Paslibintf,} QGraphics {, Events, Dialogs,}
  //   {Memory, windows} ; {Packages, ToolUtils, OSUtils}


  {$R-}   
	
  const
	          
    num_errors = 330;
	  block = 268435456;    { 2 to the 28 (= logblock) }
		two_to_28 = 268435456.00;
    halfblock = 16384;    { 2 to the 14 }  
    subblock = 134217728;  { 2 to the 27 }
		mask = 16383;          { 2 to the 14 minus 1 }
		bigmask = 268435455;   { 2 to the 28 - 1 }
		mediummask = 16777215;   { 2 to the 24 - 1 }
    logblock = 28;
		arrstashsize = 2000;
		num_arrptr = 200;
    arr_block_size = 1024;
		tenmask = 1023;
		last_arr_spot = 204799;  { 1024 * 200 - 1.  number of spots for all arrays. }
    statsize = 500;
    size_r_powers = 147;
    arr_limit = 40000;   { max size for any one array }
    psuedo_logblock = 8;
	  psuedo_block = 100000000;
		negblock = -268435456;
		neg_two_to_31 = -2147483647;
		two_to_31 = 2147483647;
		size_builtin = 127;
		graphsize = 100;
		maxquad = 4000;
		impossibl = -31000;   { hope this can never be a pixel address! }
		factlimit = 170.0; { May 1997; 1754.0; }
		full_charpol = 198;      { dimension of highest char poly ever used. (full_charpol+2)^2 = arr_limit) }
		charpol = 38;            { dimension of highest char poly stored in disk file. }
		in_house_charpol = 18;   { dimension of highest char poly stored in array. }
		first_step = 11;         { dimension of highest char poly loaded first. }
    sparsesize = 64; {full_charpol+2;  ```}
		worksize = 5; 
    Animate_ = 0;
		Arccos_ = 1;
    Arcsin_ = 2;
		Arctan_ = 3;
    Arctanh_ = 4;
    Array_ = 5;    { Nov 1997 }
		CFuncplot_ = 6;
    CLine_ = 7;
    CPlot_ = 8;
    Carve_ = 9;
    Cfunc_ = 10;
    Chpoly_ = 11;
		Codeg_ = 12;
    Colreduce_ = 13;
    Cols_ = 14;
    Content_ = 15;
    Contrast_ = 16;
    Copy_ = 17;
		Cos_ = 18;
    Cosh_ = 19;
    Cut_ = 20;
		Deg_ = 21;
    Delete_ = 22;
    Denom_ = 23;
		Deriv_ = 24;
		Det_ = 25;
		Det__ = 26;   { Apr 1998 }
    ERotate_ = 27;
    ETrans_ = 28;
    Erase_ = 29;
		Exp_ = 30;
    False_ = 31;
    Func_ = 32;       { Nov 1997 }
		Funcplot_ = 33;
    Function_ = 34;   { Nov 1997 }
		GCD_ = 35;
    Height_ = 36;
    Hide_ = 37;
    Im_ = 38;  { Jan 1998 }
    Intcolred_ = 39;
    Intnormal_ = 40;
    Iszero_ = 41;
    Join_ = 42;
    Lcoef_ = 43;
    Level_ = 44;
    Line_ = 45;
		Ln_ = 46;
    Lower_ = 47;
		Lterm_ = 48;
    Mark_ = 49;
    Minpoly_ = 50;
    Normalize_ = 51;
    Numb_ = 52;
    Numcon_ = 53;
    Numer_ = 54;
    OColor_ = 55;  { Jan 1998 }
    ODump_ = 56;
		OIColor_ = 57;  { Jan 1998 }
		Objarray_ = 58;
    Penstyle_ = 59;
    Pfunc_ = 60;
    Plot_ = 61;
    Polygon_ = 62;
    Raise_ = 63;
    Rcoef_ = 64;  { Nov 1997 }
		Re_ = 65;  { Jan 1998 }
		Rect_ = 66;
    Redraw_ = 67;
    Redrowech_ = 68;  { Oct 2000 }
    RemQuot_ = 69;
    Return_ = 70;
    Reverse_ = 71;
    Rint_ = 72;
    Rname_ = 73;  { Nov 1997 }  
		Root1_ = 74;
		Rotate_ = 75;
    SColor_ = 76;  { Jan 1998 }
    Setaxes_ = 77;
    Setobj_ = 78;
    Setscale_ = 79;
    Setthree_ = 80;
    Shade_ = 81;
    Show_ = 82;
		Sin_ = 83;
    Sinh_ = 84;
    Solid_ = 85;
    Sparse_ = 86;
		Sqrt_ = 87;
    Sumup_ = 88;
    Surface_ = 89;
    Switchcol_ = 90;
    Switchrow_ = 91;
		Tan_ = 92;
    Threeplot_ = 93;
    Trace_ = 94;
    Trans_ = 95;
    Transform_ = 96;
    True_ = 97;
    Union_ = 98;
    Unmark_ = 99;
		Var_ = 100;
    View_ = 101;
    Warp_ = 102;
    Wash_ = 103;
    Window_ = 104;
    ZLine_ = 105;
		ZPlot_ = 106;
		ZSphere_ = 107;
    Zoom_ = 108;
		

  type

    longreal = Extended;
	
  	nametype = string[10];
	  
	  medstring = string[61];  {@@@}
		
		floatptr = ^longreal;
		
		textptr = ^text;
		
		tokentipe = record
		               name: nametype;
									 address: integer
							  end;
		
    stuff = set of char;

    imptr = ^number; 
    number = record
                size: integer;
							  float: longreal; 
							  imag: imptr
             end;
						 
		numptr = ^numnode;
    numnode = record
                 value: longint; 
                 next: numptr
              end;

    snumber = record
								 head: numptr;
								 tail: numptr;
								 size: integer;
								 float: longreal
              end;
						 
    poly = ^polynode;
		polynode = record
		              exp: longint;
									next: poly;
									case numb: boolean of
									   true : (ncoef: imptr);
										 false: (pcoef: poly)
							 end;
							 
		quoly = ^quolynode;
		quolynode = record
		               next: quoly;
		               case numb: boolean of
									    true : (ncoef: imptr);
										  false: (numer, denom: poly)									 
							  end;

    quolyptr = ^quoly;
		polyptrr = ^poly;  {spar}
		
	  objptr = ^myobject;
		objptrptr = ^objptr;

    varptr = ^varnode;
    varnode = record
                 let: tokentipe;
								 next: varptr;          
                 qp: quolyptr;
								 obj: objptrptr;
								 val: quoly
              end;

    classtype = (one, two, three);  { used in namenode below and for classifying
		                                  size of the modulus }
		
		nameptr = ^namenode;
    namenode = record
                  let: tokentipe;     { ############# }
								  nother: nameptr;        { next node with same name }
									qp: quolyptr;          { compiled value }
                  next: nameptr;
									compiled, space: boolean;     { used by compiler }
									           { space added Dec 1997; used by funcdef }
									tipe: classtype
               end;
							 
    polypt = ^polydata;
		polydata = record
		              let: tokentipe;
								  expon: longint;
								  p: poly;
								  next: polypt
							 end;

    condexptr = ^condnode;
    formptr = ^formnode;
    condnode = record
                 cond: nameptr;
                 aloop: boolean;
                 form1: formptr;
                 form2: formptr;
                 expr: nameptr;
								 next: condexptr
               end;
							 
		comptr = ^comnode;
		comnode = record
								q: nameptr;
								next: comptr
							end;

    formnode = record
                 cptr: condexptr;
								 comms: comptr;
                 next: formptr
               end;    
		
		paramptr = ^paramnode;
		paramnode = record
		               let: tokentipe;        
									 nother: nameptr;
									 qp: quolyptr;
									 result, arry, isobject, sparse: boolean;
									 next: paramptr
								end;
								
		funcptr = ^funcnode;
    funcnode = record
                  name: tokentipe;
                  pars: paramptr;       
                  rht: formptr;
									comp: formptr;  { compiled part }
									do_params: boolean; 
                  next: funcptr
               end;
							 
		func_st_type = array[0..70] of funcptr;

		colptr = ^col_pair;
	  col_pair = record
								  i, j: longint;
									f: quoly;
								  next: colptr
							 end;					
		
		{ sparse matrix types } 
		colm_ptrptr = ^colm_ptr;
		colm_ptr = ^colnode;
		colnode = record
		             coord: longint;  { usually a column }
								 val: quoly; 
								 next: colm_ptr
							end;
		
		sparseptr = ^rowarray;
		rowarray = record
		              indx: array[1..sparsesize] of colm_ptr;
									notdone  { for adjoining/canceling poly vars }
										 : boolean;
									next: sparseptr
							 end;
							 
		quol_array = array[1..2] of quoly;
		varp_array = array[1..2] of varptr;
		loc_array = array[1..15] of varptr;
		loc_val_array = array[1..15] of quoly;

    arrptr = ^arrnode;
    arrnode = record 
                name: tokentipe;
                start: longint;   { for created sparse, = 0 }
                stop: longint;    { for created sparse, = -1 }
								size: longint;    { for normal, = stop-start+1 }
                rows: longint;
								spar: sparseptr;
                next, father: arrptr;
								time: longint
              end;

    statptr = ^statnode;
    statnode = record
                 prev: statptr;
                 f: funcptr;
                 next: statptr
               end;
							 
    messptr = ^messarray;
		messarray = array [1..num_errors] of medstring;  {@@@}
								
		storeptr = ^storerec; 
		storerec = array [0..arr_block_size - 1] of quoly;

    one_array = array[0..num_arrptr - 1] of storeptr; 
		workptr = ^workarray;
		workarray =  array[0..arr_limit - 1] of quoly;
		small_workarray = array[0..99] of quoly;
								
    arr_descr = array [1..2] of longint;
						
		boolarray = array[1..4] of boolean;
		
		extarray = array[0..2] of longreal;
		evector = array[1..3] of longreal;
		f_vector = array[1..4] of longreal;
		fvptr = ^f_vector;
		twobytwo = array[1..2, 1..2] of longreal;
		
    lineptr = ^linerec;
		linerec = record
		             abscoord: array[1..4] of integer;
								 locoord: array[1..6] of real;
								 rred, ggreen, bblue: integer;  { Jan 1998 }
								 for_real, show: boolean;
								 next: lineptr
							end;
		lineptrptr = ^lineptr;
							
		edgeptr = ^edgerec;
		edgerec = record        { needs greater accuracy than linerec }
		             abscoord: array[1..4] of integer;
								 locoord: array[1..6] of longreal;
								 fresh: boolean;
								 next: edgeptr
							end;
							
		graphptr = ^graphrec;  { points in an object }
		graphrec = record
		              abscoord: array[1..2*graphsize] of integer;
									locoord: array[1..3*graphsize] of real;
									colors: array[1..3*graphsize] of integer;  { Jan 1998 }
									next: graphptr
							 end;
							 
		graphptrptr = ^graphptr;  {```}
		
		sidesptr = ^sides;
		sides = record
		           left, right, top, bottom: lineptr;
							 depth: longreal;
							 next: sidesptr
						end;
						
		quaddata = record
		              left, right: integer;
									q: sidesptr
							 end;
							 
		quadptr = ^quadarry;
		quadarry = record
		              quad: array[1..maxquad] of quaddata;
									next: quadptr
							 end;
							 
	  coordptr = ^coordrec;
		coordrec = record
		              a, b: integer;
		              x, y, z: longreal;
									keep, bdy: boolean;     { used by Cut }
									cp: coordptr
		           end;
		coordptrptr = ^coordptr;
							 
		polygon_ptr = ^polygonrec;
		polygonrec = record
		                x, y, z: longreal;  { the unit normal vector }
										xcen, ycen, zcen: longreal;  { the centroid }
										radius: longreal;   { half the diameter of the polygon }
										dist: longreal;     { distance to reference point; set and used only by sort }
										rank: longint;    { number of vertices }
										cp: coordptr;     { list of vertices }
										rred, ggreen, bblue: integer;  { Jan 1998 }
										trash: boolean;   { used by Cut solid only }
										face,             { next face in polyhedron }
										   link,          { used only by Copy }
											 gg: polygon_ptr    { next polygon record }
							   end;
		gonptrptr = ^polygon_ptr;
								 
		myobject = record   { Don't add anything called sine, cosine, x, y, z, r, or s. }
		            name: nametype;
								obarray, shaded, solid, threeD: boolean;
								init: integer;    { address for arrays, number of quads for hide-lines. }
								first, last: graphptr;
								final: integer;
								bias: evector;  { 0 or unit vector; set by Cut }
								line, lasline: lineptr;
								sintheta, z_cosine,
								   xscale, yscale, zscale: longreal;
								xmin, xmax, ymin, ymax, zmin, zmax: longreal;  { bounds of three-d object }
								quads: quadptr;  { nil = ordinary object, else hidden-line object. }
								gons, lastgon: polygon_ptr; 
								headvert, endvert: coordptr;  { last polygon coord record }
								next: objptr
						 end;
						 
		factptr = ^factnode;
		factnode = record
									first, sec: polygon_ptr;
									fresh: boolean;
									next: factptr
							 end;
							 
		grouptr = ^groupnode;
		groupnode = record
										gon: polygon_ptr;
										sub, next: grouptr
								end;

		obj_array = array[1..1000] of objptr;  { storage for objects }
		obj_ar_ptr = ^obj_array;

		crossings = array[1..4] of integer;

		binomptr = ^binomarray;
		binomarray = array[1..1900] of longreal;
    alertkeys = (noAlertKey, PanicKey, NewCommandLevel);

  var

		numhead: numptr;
		sysnum, prevnum, quolygarb: quoly;
    number_0, number_1, number_2, number_m1, number_10, disp_cons, num_log_2,
		     num_log_r, num_log_10, rand_denom_n, num_2_14, pii: number;
    statcount, m_interrupt, addresser, disp_size,
         sqcut, func_def_count, badcount, namelength, array_time: longint;
    token: tokentipe;
		imhead: imptr;
    var_garb: varptr;
		name_garb: nameptr;
		spargarb: sparseptr;
		col_garb: colm_ptr;
		colgarb: colptr;
		sca_store: array[0..150] of varptr;
		arr_store: array[0..150] of arrptr;
		func_store: func_st_type;
    arr_garb, syst, duparr: arrptr;
    inpuf, outpuf, ferstartup, siouxdata, errs18: text;
    userInput, userOutput : Text; //wwh 6/24/02
    alertKey : alertkeys;
    binoms: file of longreal;
		erp: messptr;
		arp: one_array; { main data structure for arrays}
    first, lastf, u: statptr;
    log_of_2, log_of_10, log10e, random_ext, random_ext2, two_thirty1: longreal;
    leave_flag, exit_flag, cycle_flag, complex, extra_line, noisy, realflag,
		   command_int, syst_dump, pos_mod: boolean;
    done_load, tt_flag, wantcolor, wantsolid: boolean;  { Jan 1998 }
		ones: array[0..30] of longint;
		numblocks: longint;  { number of array blocks currently activated }
    massnum, dummy: longint;
		throwaways, cond_set, poly_cond_set, term_set, big_term_set: stuff;
		tens_base, two_tensbase: number;
		cancelflag: boolean;
		builtin: array[0..size_builtin, 1..2] of nametype;
    numbuiltins: integer;
		factnum: array[0..21] of longint;
		facts: array[0..21] of longreal;

		start, finish, s2: nameptr;

		workhead: array[1..worksize] of workptr;
		dupptr: workptr;

		line_garb, sysline, curline, penult: lineptr;
		edge_garb: edgeptr;
		graph_garb, sysgraph, curgraph: graphptr;
		gon_garb, sysgon, curgon: polygon_ptr;
		sysendvert, point_garb: coordptr;
		grindex: integer;
		obj_garb: objptr;
		objlist: array[0..150] of objptr;
		obstash: obj_ar_ptr;
		quad_garb: quadptr;
		sides_garb: sidesptr;
		all_nil: loc_array;
		all_val_nil: loc_val_array;
		arrstash: array[0..arrstashsize-1] of arrptr;
		xmin, xmax, ymin, ymax, zmin, zmax, paint_c_1, paint_c_2: longreal;

		sizenumber, sizelinerec, sizedgerec, sizepolygonrec, sizecoordrec,
		   sizegraphrec, sizeobject, sizequadarry, sizesides, sizerowarray, sizecolpair,
		   sizepolynode, sizequolynode, sizecolnode, numnodesize, sizevarnode,
		   sizecomnode: longint;

		binom: binomptr;

		group_garb: grouptr;
	  fact_garb: factptr;

		cc: array[1..full_charpol] of longreal;

		formhead: formptr;
		condhead: condexptr;

		mytime: array[1..9] of TDateTime;     { These vars to keep track of elapsed time }
		breaktime: array[1..9] of TDateTime;  { at each command level. }
		time_off: array[1..9] of TDateTime;
		time_level: integer;

	 procedure newimag(var p: imptr);
	 
	 procedure newline(var p: lineptr);
	 
	 procedure newedge(var p: edgeptr);
	 
	 procedure newgraph(var p: graphptr);
	 
	 procedure newgon(var p: polygon_ptr); 
	 
	 procedure newpoint(var p: coordptr);
	 
	 procedure newobj(var p: objptr);
	 
	 procedure newsides(var p: sidesptr);
	 
	 procedure newquad(var p: quadptr);
	 
	 procedure newsparse(var p: sparseptr);
	 
	 procedure newform(var p: formptr);
	 
	 procedure newcond(var p: condexptr);
	 
	 procedure newcol(var q: colptr);
	 
	 procedure freename(p: nameptr);
	 
	 procedure free_form(var p: formptr);
	 
	 procedure free_cond(var p: condexptr);
	 
	 procedure free_obj(ob: objptr);
	 
	 procedure freegon(var p: polygon_ptr);
	 
	 procedure imag_free(var x: number); 
	 
   procedure free_imag(var p: imptr);
	 
	 procedure complex_makeneg(var n, x: number);
	 
	 procedure complex_inplace(var n: number);
	 
	 procedure imag_assign(var n, x: number);
	 
	 procedure setimag(n: longint; var x: number); 
	 
	 procedure imag_part(var n: number); 
	 
	 function complex_equal(var n, m: number): boolean; 
	 
	 procedure complex_assign(var n, x: number);
	 
	 procedure conjugate(var n, n2: number);
	 
	 procedure slide_over(var n: number);
	 
	 function equal_to_pm1(var n: number; var its_minus1: boolean): boolean;
	 
	 procedure subinitialize;
	 
	 procedure complex_set(n: longint; var x: number);
	 
	 procedure complex_great_int(var n, n2: number); 
	 
	 function imagzero(var d: number): boolean;
	 
	 function iszero(var d: number): boolean;
	 
	 function smallgcd(u, v: longint): longint;
		 
	 procedure gcdnum(var n, m: quoly);
	 	 
									 
 {**********************************************************************}
 
  implementation
	


	
	procedure newimag; { (var p: imptr) }
	
    begin
      if imhead = nil
         then new(p)
         else begin
                 p := imhead;
                 imhead := imhead^.imag
              end						 
		end;
						 
  {*********************************************************************}
	
	procedure newline; { (var p: lineptr)   Jan 1998 }
	
    begin
      if line_garb = nil
         then new(p)
         else begin
                 p := line_garb;
                 line_garb := line_garb^.next
              end;
			with p^ do
			   begin
			      for_real := true;
			      show := true;
			      rred := 0;
			      ggreen := 0;
			      bblue := 0
			   end
		end;
						 
  {*********************************************************************}
	
	procedure newedge; { (var p: edgeptr) }
	
    begin
      if edge_garb = nil
         then new(p)
         else begin
                 p := edge_garb;
                 edge_garb := edge_garb^.next
              end;
			p^.fresh := true
		end;
						 
  {*********************************************************************}
	
	procedure newgon; { (var p: polygon_ptr) }
	
    begin
       if gon_garb = nil
          then new(p)
          else begin
                  p := gon_garb;
                  gon_garb := gon_garb^.gg
               end;
       with p^ do  { Jan 1998 }
			   begin
			      rred := 0;
			      ggreen := 0;
			      bblue := 0
			   end
		end;
						 
  {**********************************************************************}
	
	procedure newcond; { (var p: condexptr) ~~~@@@ was imptr?? }
	
    begin
      if condhead = nil
         then new(p)
         else begin
                 p := condhead;
                 condhead := condhead^.next
              end						 
		end;
						 
  {**********************************************************************}
	
	procedure newform; { (var p: formptr) }
	
    begin
      if formhead = nil
         then new(p)  
         else begin
                 p := formhead;
                 formhead := formhead^.next
              end						 
		end;
						 
	{************************************************************************}
	
	procedure freename; {(p: nameptr);  p can't be nil. p is not changed! }
	
	   var t: nameptr;
		 
		 begin
		   
			  t := p;
				while t^.next <> nil do
				   t := t^.next;
					 
				t^.next := name_garb;
				name_garb := p
				
		 end;
				   	
  {********************************************************************}

  procedure free_cond { (var p: condexptr) ~~~};
    
		{ p is not nil }
		
		begin
		
			 if p^.cond <> nil
			    then freename(p^.cond);
			 free_form(p^.form1);
			 free_form(p^.form2);
			 if p^.expr <> nil
			    then freename(p^.expr);
			 p^.next := condhead;
			 condhead := p
			 
		end; 
 
  {*********************************************************************}

  procedure free_form { (var p: formptr) ~~~};
    
		{ not complete. good enough for sum_mult_up. }
		
		begin
		
			 if p <> nil
			    then begin
					        free_cond(p^.cptr);
									p^.next := formhead;
									formhead := p
							 end
			 			 
		end; 
 
  {*********************************************************************}
	
	procedure freegon; { (var p: polygon_ptr) }
     var i: longint;
		     cp: coordptr;
		 begin
		     cp := p^.cp;
				 for i := 2 to p^.rank do
				    cp := cp^.cp;
				 cp^.cp := point_garb;
				 point_garb := p^.cp;
				 p^.gg := gon_garb;
				 gon_garb := p
		 end;

  {********************************************************************}
	
	procedure newpoint; { (var p: coordptr) }
	
    begin
      if point_garb = nil
         then new(p)
         else begin
                 p := point_garb;
                 point_garb := point_garb^.cp
              end;
		end;
						 
  {******************************************************************}
	
	procedure newgraph; { (var p: graphptr) }
	
	 { Note we don't initialize the colors here, unlike lines and gons }
	
    begin
      if graph_garb = nil
         then new(p)
         else begin
                 p := graph_garb;
                 graph_garb := graph_garb^.next
              end						 
		end;
						 
 {*********************************************************************}
	
	procedure newobj; { (var p: objptr) }
	  var i: integer;
    begin
      if obj_garb = nil
         then new(p)
         else begin
                 p := obj_garb;
                 obj_garb := obj_garb^.next
              end;
			 for i := 1 to 3 do
			    p^.bias[i] := 0
		end;
						 
 {*********************************************************************}
	
	procedure newquad; { (var p: quadptr) }
	
    begin
      if quad_garb = nil
         then new(p)
         else begin
                 p := quad_garb;
                 quad_garb := quad_garb^.next
              end						 
		end;
						 
 {**********************************************************************}
	
	procedure newsides; { (var p: sidesptr) }
	
    begin
      if sides_garb = nil
         then new(p)
         else begin
                 p := sides_garb;
                 sides_garb := sides_garb^.next
              end
		end;
						 
	{******************************************************************}
	
  procedure newsparse; {(var p: sparseptr)}
	   
		begin
       if spargarb = nil
          then new(p)
          else begin
                  p := spargarb;
                  spargarb := spargarb^.next
               end
		end;
						 
	{******************************************************************}		
		
	procedure newcol; {(var q: colptr)}
	
	   begin
		    if colgarb = nil
					 then new(q)
					 else begin
									 q := colgarb;
									 colgarb := colgarb^.next
							  end;
				q^.f := nil
		 end;															 
																		 																		 
	{*********************************************************************}
		
  procedure imag_part;  { (var n: number); }
	
	   begin
	
				if n.imag = nil
					 then n.float := 0
					 else begin
									 n.imag^.imag := imhead;
									 imhead := n.imag;
									 n := n.imag^;
									 n.imag := nil   
								end
								
     end;

  {*********************************************************************}
	
	procedure free_obj; {(ob: objptr)}
	
	   { can't be an obj array }
	
	   begin
		 
		    if ob = nil
				   then exit{(free_obj)};
					 
				if ob^.first <> nil
				   then begin
					         ob^.last^.next := graph_garb;
				           graph_garb := ob^.first
								end;
				if ob^.line <> nil
				   then begin
					         ob^.lasline^.next := line_garb;
				           line_garb := ob^.line
								end;
				if ob^.quads <> nil
				   then begin
					         ob^.quads^.quad[1].q^.next := sides_garb;
									 sides_garb := ob^.quads^.quad[ob^.init].q;
									 ob^.quads^.next := quad_garb;
									 quad_garb := ob^.quads
								end;
				if ob^.gons <> nil
				   then begin
					         ob^.endvert^.cp := point_garb;
									 point_garb := ob^.headvert;
									 ob^.lastgon^.gg := gon_garb;
					         gon_garb := ob^.gons
					      end;
					         
				ob^.next := obj_garb;
				obj_garb := ob
				
		 end;
								
	{**********************************************************************}
	
	procedure imag_free;  {  (var x: number); }
	
	   begin
		 
				if x.imag <> nil
				   then begin
									 x.imag^.imag := imhead;
									 imhead := x.imag;
									 x.imag := nil   
								end 
								
		 end;
		 
  {***********************************************************************}

  procedure free_imag { (var p: imptr) };
    
		begin
		
			 if p <> nil  { added this test in Nov 1994 }
			    then begin
					        if p^.imag = nil
										 then p^.imag := imhead
										 else p^.imag^.imag := imhead;
								  imhead := p;
								  p := nil
							 end
			 
		end;
 
  {*********************************************************************}

  procedure complex_assign; { (var n, x: number); }
	
  { set x equal to n.  both parts of a complex number.}

    begin
		
		   x.float := n.float;
		
       if n.imag <> nil
			    then imag_assign(n, x)
			    else if x.imag <> nil
				          then begin
												  x.imag^.imag := imhead;
									        imhead := x.imag;
									        x.imag := nil   
								       end
			
    end;

  {********************************************************************}
	
	procedure complex_inplace;   { (var n: number) }
	
	  begin
		   
			n.float := - n.float;
			 
      if n.imag <> nil
			   then n.imag^.float := - n.imag^.float
												 
	  end;
		
	{********************************************************************}
	
	procedure imag_assign; { (var n, x: number);}
	
	  { n is a number with an imaginary part.  x may or may not have an imaginary 
		  part.  set imag(x) = imag(n).  }
	
	  begin
		   
			  if x.imag = nil
				   then newimag(x.imag);

        x.imag^.float := n.imag^.float				 

    end;
		
  {*********************************************************************}

  procedure setimag; { (n: longint; var x: number); }
	
	  { set imaginary part of x equal to n. }
	
    begin
		
		  if x.imag = nil
			   then newimag(x.imag);
			
			x.imag^.float := n
			
    end;
		
	{*******************************************************************}
	
	function imagzero { (var d: number): boolean} ;
	
	   { is the imaginary part of complex d = 0? }
	
	    begin
			  
				 if d.imag <> nil
						 then if d.imag^.float = 0
												then begin
																 imagzero := true;
																 writeln('***** Fermat error imag zero');
																 flush(output)
														 end
												else imagzero := false
						 else imagzero := true
								 
       end;
				 
  {*********************************************************************}
	
	procedure conjugate; { (var n, n2: number); }
	
	  begin
		
		   n2.float := n.float;
       if n.imag <> nil
			    then begin
					        if n2.imag = nil
				             then newimag(n2.imag);
                  n2.imag^.float := -n.imag^.float
							 end
			    else if n2.imag <> nil
				          then begin
												  n2.imag^.imag := imhead;
									        imhead := n2.imag;
									        n2.imag := nil   
								       end
					
		end;
		
	{**********************************************************************}
	
  procedure slide_over;  { (var n: number); }
	
	 { transfer real part to imaginary part. n must be the real part of a complex.
	   real part of n is nilled and zeroed out.}
		 
	  begin
		    
				if n.imag = nil
				   then newimag(n.imag);
				n.imag^.float := n.float;
				n.float := 0
				
		end;
				
 {************************************************************************}
  	 
	procedure subinitialize;
	
	   var i: longint;
	
	   begin
	 	  		
				numhead := nil;
				
				sizenumber := sizeof(number);  {@@@}
				sizelinerec := sizeof(linerec);
				sizedgerec := sizeof(edgerec);
				sizepolygonrec := sizeof(polygonrec);
				sizecoordrec := sizeof(coordrec);
				sizegraphrec := sizeof(graphrec);
				sizeobject := sizeof(myobject);
				sizequadarry := sizeof(quadarry);
				sizesides := sizeof(sides);
				sizerowarray := sizeof(rowarray);
				sizecolpair := sizeof(col_pair);
				sizepolynode := sizeof(polynode);
				sizequolynode := sizeof(quolynode);
				sizecolnode := sizeof(colnode);
				numnodesize := sizeof(numnode);
				sizevarnode := sizeof(varnode);
				sizecomnode := sizeof(comnode);
				
			  time_level := 1;  
			  time_off[1] := 0;
				badcount := 0;
				var_garb := nil;
				name_garb := nil;
				quad_garb := nil;
		    sides_garb := nil;
				line_garb := nil;
				edge_garb := nil;
				group_garb := nil;
		    fact_garb := nil;
				graph_garb := nil;
				obj_garb := nil;
				sysgraph := nil;
				sysline := nil;
				obstash := nil;
				gon_garb := nil;
				point_garb := nil;
				sysgon := nil;
				curgon := nil;
				imhead := nil;
				spargarb := nil;
			  col_garb := nil;
				token.name := '';
				token.address := -1;
				namelength := 10;
				array_time := 1;
				cancelflag := false;
				extra_line := true;
				complex := false;
				pos_mod := true;
				formhead := nil;  {~~~}
			  condhead := nil;  {~~~}
        realflag := false;
				colgarb := nil;
		
				for i := 0 to 150 do
				   objlist[i] := nil;
		
				sqcut := 16;
		
				arr_garb := nil;
				numblocks := -1;
				tt_flag := true;
				done_load := false;
				wantcolor := true;  { Jan 1998 }
				wantsolid := false;  { Jan 1998 }
				func_def_count := 0;
				new(erp);  {@@@}
		  	random_ext := 1257;  
			  random_ext2 := 1;   { internal Fermat use }
				two_thirty1 := 2147483647.0;  { 2 to 31 minus 1 }
				
				throwaways := [ ' ', chr(9), chr(10), chr(13) ]; { used by scanner }
				cond_set := [ '>', '<', '=', '', '', '' ];  { conditionals }
				poly_cond_set := [ '=', '' ];  { ok to use with polys }
				term_set := [ '*', '/', '\', '|' ];
				big_term_set := [ '*', '/', '\', '|', '', '', '(' ];  { Dec 1997 }
				
				new(duparr);  {@@@} 
				duparr^.start := 0;
				duparr^.stop := -1;
				duparr^.rows := 0;
				duparr^.size := 0;  {```}
				duparr^.next := nil; 
				duparr^.spar := nil;
				duparr^.name.name := '  ';
			
			  for i := 1 to worksize do  
			     workhead[i] := nil;
			  AssignFile(errs18, 'Ferrs');
				reset(errs18);
				if eof(errs18)
					 then writeln('*** Fermat error. can''t find Ferrs.');				
				 
				for i := 1 to num_errors do
					 readln(errs18, erp^[i]);
					
				readln(errs18);
				rand_denom_n.float := 1.0;
				rand_denom_n.imag := nil;
				number_0.float := 0;
				number_0.imag := nil;
				number_1.float := 1;
				number_1.imag := nil;
				number_2.float := 2;
				number_2.imag := nil;
				number_m1.float := -1;
				number_m1.imag := nil;
				num_2_14.float := halfblock;
				num_2_14.imag := nil;
				number_10.float := 10;
				number_10.imag := nil;
				pii.float := 3.14159265358979323846264;
				pii.size := 0;
				pii.imag := nil;
				paint_c_1 := 7/16;  { Jan 1998; means default &p is 1/8. }
				paint_c_2 := 9/16;
				
				log_of_2 := ln(2);
				log_of_10 := ln(10);
				log10e := 1/log_of_10;  {@@@}
					 
				ones[0] := 0;
				ones[1] := 1;
				for i := 2 to 30 do
					 ones[i] := 2*ones[i-1] + 1;
					 
				leave_flag := false;
				exit_flag := false;
				cycle_flag := false;
				command_int := true;
				m_interrupt := 1;
		
				{ Create circular list for recent function activations .}
				
				u := nil;
				for i := 1 to statsize do
					begin
						new(lastf);
						lastf^.prev := u;
						if i = 1
							 then first := lastf
							 else u^.next := lastf;
						u := lastf
					end;
				lastf^.next := first;
				first^.prev := lastf;
				statcount := 0;
		
				{ Create circular list for tokens read from terminal .}
				
				finish := nil;
				for i := 1 to 60 do
					begin
						new(start);
						if finish = nil
							 then s2 := start
							 else finish^.next := start;
						finish := start
					end;
				start^.next := s2;
				
				{ Initialize basic variables. }
				
				sysnum := nil;
				prevnum := nil;
				for i := 0 to 150 do
					 sca_store[i] := nil;
				for i := 0 to 150 do
					 arr_store[i] := nil;
				for i := 0 to 70 do
					 func_store[i] := nil;
										 
				{ Create table of builtin functions. }
				readln(errs18, numbuiltins);
				if numbuiltins > size_builtin
					 then writeln('*** Fermat error. number builtins.');
				for i := 0 to numbuiltins do
					 begin
							readln(errs18, builtin[i,1]);
							readln(errs18, builtin[i,2]);
					 end;
				for i := numbuiltins + 1 to size_builtin do
					 begin
							builtin[i,1] := 'b';
							builtin[i,2] := ''
					 end;
					 
				for i := 0 to 21 do
					 read(errs18, factnum[i]);
				for i := 0 to 21 do
					 read(errs18, facts[i]);
					 
				close(errs18);
				for i := 0 to arrstashsize-1 do
					 arrstash[i] := nil;
					 
				for i := 1 to 15 do
				   all_nil[i] := nil;
				for i := 1 to 15 do
				   all_val_nil[i] := nil;

				AssignFile(binoms, 'binoms');
        reset(binoms {, sizeof(longreal)});
				if eof(binoms)
					 then writeln('*** Fermat error. can''t find binoms.');	
			{	seek(binoms, 147782); @@@}
				new(binom);

				for i := 1 to 1900 do
        	begin
          	if eof(binoms) then
            	 break;
				   	read(binoms, binom^[i])
          end;
        close(binoms);

				flush(output)
							 				
	   end;

 {*********************************************************************}

  function equal_to_pm1; { var n: number; var its_minus1: boolean }
		
	  begin 
		  
			 its_minus1 := complex_equal(n, number_m1);
			 equal_to_pm1 := its_minus1 or complex_equal(n, number_1)
			 
		end;
		
  {********************************************************************}
	
	procedure complex_great_int; { (var n, n2: number);}
	
	   begin
		 
		    n2.float := trunc(n.float);
				if n.imag <> nil
				   then begin
					         if n2.imag=nil
					            then newimag(n2.imag);
									 n2.imag^.float := trunc(n.imag^.float);
									 if n2.imag^.float = 0
									    then imag_free(n2)
								end
				else imag_free(n2)
				
		 end;
		 
  {*********************************************************************}
	
	procedure complex_makeneg;   { (var n, x: number) }
	
	  begin
		   
			x.float := - n.float;
			 
      if n.imag <> nil
			  then if x.imag=nil
				         then begin
								         newimag(x.imag);
												 x.imag^.float := - n.imag^.float
											end
								 else x.imag^.float := - n.imag^.float
												 
			  else if x.imag <> nil
				         then begin
												 x.imag^.imag := imhead;
												 imhead := x.imag;
									       x.imag := nil   
								      end;
											
	  end;
		
 {*******************************************************************}
 
 function complex_equal; { (var n, m: number): boolean;  }
 
   begin 
	   
		   if (n.imag=nil) and (m.imag <> nil)
			    then complex_equal := false
			 else if (m.imag=nil) and (n.imag <> nil)
			    then complex_equal := false
			 else if n.imag = nil
			    then complex_equal := (n.float = m.float)
			 else if (n.float = m.float)
			         then complex_equal := (n.imag^.float = m.imag^.float)
							 else complex_equal := false
						
	 end;
							 
  {**************************************************************************}
	
	procedure complex_set; { (n: longint; var x: number) } 
	
	   begin
		    
				x.float := n;
        if x.imag <> nil
				   then begin
									 x.imag^.imag := imhead;
									 imhead := x.imag;
									 x.imag := nil   
								end;

		 end;
		 
	{*******************************************************************}
	
	function iszero { (var d: number): boolean };
	
	   { is the complex d = 0? }
	
	    begin
			  
				 iszero := (d.float = 0) and imagzero(d)
				 
      end;
				 
  {*******************************************************************}

  function smallgcd;  { (u, v:longint): longint;}
	
	  { binary gcd algorithm for longintegers. u and v must be positive.
		  always returns positive }

    var k, t: longint;

    begin
		
		    { divide out largest common power of 2 }
		    k := 0;
				while not ( (u and 1 <> 0) or (v and 1 <> 0) ) do
				    begin
						    k := k + 1;
								u := u shr 1;
								v := v shr 1
					  end;
						
				if u and 1 <> 0    { u is odd }
				    then while v and 0 = 0 do
						        v := v shr 1
						else repeat  { u is even }
						        u := u shr 1
								 until u and 1 <> 0;
								 
				{ now both are odd }
				
				 t := abs(u - v);
				 while t>0 do 
				    begin
						    while not t and 1 <> 0 do
					         t := t shr 1;
					      if u < v
					         then v := t
							     else u := t;
					      t := abs(u - v)
				    end;
				
				smallgcd := u * ( ones[k] + 1 )
		
    end;

  {*********************************************************************}
	
	procedure gcd_float(var n: number; m: number);
	
	   var modul: longreal;

     begin
		 
				while m.float <> 0 do
				   begin   
					    modul := n.float - m.float * trunc(n.float/m.float);
							n.float := m.float;
							m.float := modul
					 end;
				n.float := abs(n.float)
		 
		 end;
		 
  {********************************************************************}
	
	procedure gcdnum;  { (var n, m: quoly); }
	
	   { n amd m are numbers. m is expendable. return answer in n. }
		 
		 var p, q: imptr;
	
	   begin
		 
		    p := n^.ncoef;
				q := m^.ncoef;
				if (p^.imag <> nil) or (q^.imag <> nil)
				   then writeln('Warning.  GCD of complex numbers not implemented.')
				else begin
					         p^.float := round(p^.float);  {@@@}
									 q^.float := round(q^.float);
									 gcd_float(p^, q^)
								end
		 
		 end;


				
end.